<?php
//v 2.0.2

//Admin-Settings Lucente Tab for similar_ideas module.
function similar_ideas_admin($arguments) {		
	switch ($arguments) {
		case 'lucene':						
			$content = similar_ideas_adminlucene();
			break;
		case 'relations':
			$content = similar_ideas_adminrelations();
			break;
		case 'search_types':
			$content = similar_ideas_searchtypes();
			break;
	}
	
	return $content;
}





//Admin-Settings Lucene Config tab for similar_ideas module.
function similar_ideas_adminlucene() {			
	$content = "<div>This is the page to configure all the Similar Ideas module settings.</div>";
	$content .= build_luceneform();
	return $content;
}

//Admin-Settings Relationships types tab for similar_ideas module.
function similar_ideas_adminrelations() {	
	global $base_path;		
	$content = "<div>In this page you can edit and delete existing relationship types or create your custom ones.";
	//$fields = get_relation_fields();
	
	$result = db_query("SELECT * FROM similar_ideas_relationtypes");
	while ($field = db_fetch_object($result)){ 
	
		if ($field->symetric == '1') {
			$sym = " (<font color='green'>symmetric</font>)";
			$inv = "";
		}else if ($field->inverse != 'none'){
			$inv = " (<font color='blue'>inverse: ".substr($field->inverse, 15)."</font>)";
			$sym = "";
		}else{
			$sym = "";
			$inv = "";
		}
		
		$name = substr($field->name, 15);
		$id = $field->id;
		//$conf ="<span><a href='".$base_path."?q=admin/settings/similar_ideas_editfield/".$id."'>edit</a></span>";
		$del = "<span><a href='".$base_path."?q=admin/settings/similar_ideas_deletefield/".$field->name."'>remove</a></span>";	
		$rows[] = array($name.$sym.$inv,$del);//$conf,$del); 
	}
	$header = array("Current relationships types:","");//,"");
	$content .= theme('table', $header, $rows);
	$content .= "<br>";
	$content .= "<fieldset><legend>Add new relationship type</legend>";
	$content .= build_fieldsform();
	
	$content .= "</div>";
	return $content;
}

//Admin-Settings Search Types tab for similar_ideas module.
function similar_ideas_searchtypes() {
	global $base_path;		
	$content = "<div>In this page you can create, configure and delete the different similarity types you can use with the similarity module.";
	
	$result = db_query("SELECT * FROM similar_ideas_searchtypes");
	$dist = "";
	while ($data = db_fetch_object($result)){ 
		if ($data->id > 1){
			$editlink = "<a href='".$base_path."?q=admin/settings/similar_ideas_editsearch/".$data->id."'>Edit</a>";
			$deletelink = "<a href='".$base_path."?q=admin/settings/similar_ideas_deletesearch/".$data->id."'>Delete</a>";
			if ($data->type == 'taxonomy') $dist = "(<font color='green'>".$data->distance."</font>)";
			else $dist='';
		}
		$rows[] = array($data->name,$data->type." ".$dist,$editlink,$deletelink);	
	}
	
	$header = array("Search name","Type of similarity (Distance)","","");
	$content .= theme('table', $header, $rows);
	$content .= "<br>";
	
	$content .= "<fieldset class='collapsible collapsed'><legend>".t('Add new taxonomy search type')."</legend>";
	$content .= build_searchtypeform();
	$content .= "</fieldset>";
	
	
	$content .= "<fieldset class='collapsible collapsed'><legend>".t('Add new mixed search type')."</legend>";
	$content .= build_mixedsearchtypeform();
	$content .= "</fieldset>";
	
	$content .= "</div>";
	
	return $content;
}


//Form with the elements for the module config.
function luceneform($form_state){
	//Getting all stored values for setting defaults.
	$ndisplayed = variable_get('similar_ideas_ndisplayed', '5');
	$afteredit = variable_get('similar_ideas_afteredit', '1');
	$aftercreate = variable_get('similar_ideas_aftercreate', '1');
	$fulltree = variable_get('similar_ideas_fulltree', '0');
	$symetric = variable_get('similar_ideas_symetric', '1');
	
	$form['displayed'] = array(
	  '#type' => 'textfield',	 
	  '#title' => t('Number of similarities to display'),
	  '#default_value' => $ndisplayed,	  
	  '#suffix' => "</ul><br>",
	  '#description' => t('Allowed values 1-20. Default: 5'),
	  '#size' => 5,
	  '#maxlength' => 2,
	  '#required' => TRUE,
	);
	$form['aftercreate'] = array(
  	  '#type' => 'checkbox',
  	  '#title' => t('Show page with similarities after every idea created'),
	  '#description' => t('If enabled, after creating an idea, page showing similarities will be displayed.'),
	  '#return_value' => '1',
	  '#default_value' => $aftercreate,
	);
	$form['afteredit'] = array(
  	  '#type' => 'checkbox',
  	  '#title' => t('Show page with similarities after one idea edited'),
	  '#description' => t('If enabled, after editing an idea, page showing similarities will be displayed.'),
	  '#return_value' => '1',
	  '#default_value' => $afteredit,
	);
	$form['fulltree'] = array(
	  '#prefix' => '<br>',
  	  '#type' => 'checkbox',
  	  '#title' => t('Index all parents terms of the taxonomy tree'),
	  '#description' => t('If enabled, for every term index for searching, also all of it\'s parents will be index too.<br><strong>Note:</strong> Remember to Re-Index if you want to apply this configuration in previous content.'),
	  '#return_value' => '1',
	  '#default_value' => $fulltree,
	);	
	$form['save'] = array(
		  '#type' => 'submit',	   
		  '#value' => t('Save Configuration'),	  
	);
	$form['restore'] = array(
		  '#type' => 'button',	   
		  '#value' => t('Restore defaults'),	 
		  '#executes_submit_callback' => TRUE,
		  '#submit' => array('adminmainform_restore'),
	);
	return $form;
}

function build_luceneform() {  
	return drupal_get_form('luceneform');
}

function luceneform_validate($form, &$form_state) {
  $ndisplayed = $form_state['values']['displayed'];
  if ($ndisplayed < 1 || $ndisplayed > 20) {
    form_set_error('', 'Number of similarities to display must be between 1 and 20.');
  }
}

function luceneform_submit($form, $form_state) {
	$ndisplayed = $form_state['values']['displayed'];
	variable_set('similar_ideas_ndisplayed', $ndisplayed);	
	$afteredit = $form_state['values']['afteredit'];
	variable_set('similar_ideas_afteredit', $afteredit);
	$aftercreate = $form_state['values']['aftercreate'];
	variable_set('similar_ideas_aftercreate', $aftercreate);
	$fulltree = $form_state['values']['fulltree'];
	variable_set('similar_ideas_fulltree', $fulltree);
	drupal_goto("admin/settings/similar_ideas");
}

function adminmainform_restore($form, $form_state) {	
	variable_set('similar_ideas_ndisplayed', '5');
	variable_set('similar_ideas_afteredit', '1');
	variable_set('similar_ideas_aftercreate', '1');
	variable_set('similar_ideas_fulltree', '0');
	drupal_goto("admin/settings/similar_ideas");
}



//Form with the elements for the add field form.
function fieldsform($form_state){	
	$options['none'] = 'No Inverse';
	
	$result = db_query("SELECT * FROM similar_ideas_relationtypes");	
	while ($data = db_fetch_object($result)){ 
		$options[$data->name] = ucfirst(substr($data->name,15));
	}
	
	$form['name'] = array(
	  '#type' => 'textfield',	 
	  '#title' => 'Relationship name',
	  '#default_value' => '',	  	
	  '#size' => 20,
	  '#maxlength' => 17,	  
	  '#description' => 'Allowed characters: _;a-z;A-Z;0-9. Min Lenght: 4 ',
	  '#required' => TRUE,
	);
	$form['inverse'] = array(  
		'#prefix' => '<br>',	
		'#type' => 'textfield',   		
		'#title' => t('Inverse Relationship'),
	    '#description' => t('Choose inverse relationship if necessary.'),
	    '#size' => 40, 
      	'#maxlength' => 17, 
		'#autocomplete_path' => 'relations/autocomplete' 
    ); 
	$form['symetric'] = array(	  
  	  '#type' => 'checkbox',
  	  '#title' => t('Set symetric relationships'),
	  '#description' => t('If enabled, for every relationship added, both ideas involved will have the relationship.'),
	  '#return_value' => '1',
	  '#default_value' => '0',
	);	
	
	$form['save'] = array(
		  '#type' => 'submit',	   
		  '#value' => 'Add relationship type',	  
	);
	return $form;
}

//Autocomplete for the inverse textbox inside RelationShip Types tab.
function relations_autocomplete($string) { 
  $matches = array();
  $result = db_query_range("SELECT name FROM {similar_ideas_relationtypes} WHERE LOWER(name) LIKE LOWER('field_relation_%s%%')", $string, 0, 10);
  while ($idea = db_fetch_object($result)) {
	$name= substr($idea->name,15);
    $matches[$name] = check_plain($name);
  }
  print drupal_to_js($matches);
  exit();
}

function build_fieldsform() {  
	return drupal_get_form('fieldsform');
}

function fieldsform_validate($form, $form_state){
	$name = $form_state['values']['name'];
	if (strlen($name) < 4) form_set_error('', 'The minimum lenght allowed is 4 characters.');
	if (!ereg("^[a-zA-Z0-9\-_]{4,17}$", $name)) form_set_error('', 'Change name according to allowed characters: _;a-z;A-Z;0-9.');
	
	
	$fields = get_relation_fields();
	foreach ($fields as $field){
		if (strtolower($name) == substr($field, 15)) form_set_error('', 'This name is already used as a relationship type, please use a different one.');
	}
	
	//Comprobar que pongamos inversa en una simetrica.
	$inverse = $form_state['values']['inverse'];
	if ($inverse) $inverse = "field_relation_".$inverse;
	else $inverse = 'none';
	
	$query2 = db_query("SELECT * FROM similar_ideas_relationtypes WHERE name='".$inverse."'");
	$data = db_fetch_object($query2);
	
	if ($data->symetric == 1){
		form_set_error('', "Relationship ".substr($data->name, 15)." is a symmetric relationship. You cannot create inverse for relationships that are symmetric.");
	}
}

function fieldsform_submit($form, $form_state){	
	$name2 =strtolower($form_state['values']['name']);
	
	
	include('similar_ideas.fields.inc');	
	$field = getField($name2);
	$name = $field['field_name'];
	module_load_include('inc', 'content', 'includes/content.crud');
	content_field_instance_create($field);
	
	$symetric = $form_state['values']['symetric'];	
	
	
	if($symetric == 1) {
		$inverse = $field['field_name'];
	}else{
		$symetric = 0;
		$inverse_ori = $form_state['values']['inverse'];		
		if (!$inverse_ori) $inverse = "none";
		else $inverse = "field_relation_".$inverse_ori;
		
		
		if ($inverse != 'none'){//Update previous relation to set the new one as inverse.
			
			
			//We create new relation and new inverse relation
			$inverse = "field_relation_".$inverse_ori;
			//drupal_set_message($inverse);
			$query= db_query("SELECT * FROM similar_ideas_relationtypes WHERE name='".$inverse."'");
			$data = db_fetch_object($query);
			if (!$data){
				$field = getField($inverse_ori);
				content_field_instance_create($field);
				$query = db_query("INSERT INTO similar_ideas_relationtypes (name,symetric,inverse) VALUES ('".$inverse."',".$symetric.",'".$name."')");
			}else{
			
				$query = db_query("UPDATE similar_ideas_relationtypes SET inverse='".$name."' WHERE name='".$inverse."'");
				
				$inverse_rel = substr($inverse, 15);
				$rel = substr($field['field_name'], 15);
				
				//Add inverse relation for existing ideas...			
				$query2 = db_query("SELECT * FROM similar_ideas_relations WHERE relationship_type='".$inverse_rel."'");
				while ($data = db_fetch_object($query2)){ 				
					$query=db_query("INSERT INTO  similar_ideas_relations (idea1,idea2,relationship_type,author,status,date,reviewer) VALUES (".$data->idea2.",".$data->idea1.",'".$rel."','".$data->author."','".$data->status."',".$data->date.",'".$data->reviewer."')");
					$query=db_query("INSERT INTO  similar_ideas_history (idea1,idea2,relationship_type,author,status,date,reviewer) VALUES (".$data->idea2.",".$data->idea1.",'".$rel."','".$data->author."','".$data->status."',".$data->date.",'".$data->reviewer."')");
				}
			}
		}
	}
	
	$query = db_query("INSERT INTO similar_ideas_relationtypes (name,symetric,inverse) VALUES ('".$name."',".$symetric.",'".$inverse."')");
	
	
	drupal_goto("admin/settings/similar_ideas/relations");
}

//Form with the elements for the add field form.
function searchtypeform($form_state){	

	$subtree = taxonomy_get_vocabularies($type = 'idea');
	$options = array();
	$options['all'] = t('All Vocabularies');
	foreach ($subtree as $voc){
		$options[$voc->vid]= $voc->name;
	}
	
	$form['name'] = array(
	  '#type' => 'textfield',	 
	  '#title' => t('Search Name'),
	  '#default_value' => '',	  	
	  '#size' => 25,
	  '#maxlength' => 25,
	  '#suffix' => "<br>",
	  '#description' => t('Allowed characters: _;a-z;A-Z;0-9. Min Lenght: 4'),
	  '#required' => TRUE,
	);
	
	$form['distance'] = array(
		 '#prefix' => "",
		 '#sufix' => "</ul>",
		 '#type' => 'select',		 
		 '#title' => "<ul>".t('Distance'),
		 '#options' => array(0 => 0,1 => 1,2 => 2,3 => 3,4 => 4,5 => 5,6 => 6,7 => 7,8 => 8,9 => 9),	
		 '#required' => TRUE,
		);	
	$form['threshold'] = array(
		 '#prefix' => "",
		 '#sufix' => "</ul>",
		 '#type' => 'select',		 
		 '#title' => "<ul>Threshold",
		 '#default_value' => 5,
		 '#options' => array(1 => "10%",2 => "20%",3 => "30%",4 => "40%",5 => "50%",6 => "60%",7 => "70%",8 => "80%",9 => "90%",10 => "100%"),	
		 '#required' => TRUE,
		);	
	$form['subtree'] = array(
		 '#prefix' => "<br>",
		 '#sufix' => "",
		 '#type' => 'select',		 
		 '#title' => t("Taxonomy Subtree"),
		 '#multiple' => FALSE,
		 '#default_value' => 'none',
		 '#options' => $options,
		 '#size' => 7,
		 '#required' => TRUE,
		);
	
	$form['save'] = array(
		  '#type' => 'submit',	   
		  '#value' => t('Add similarity type'),	  
	);
	return $form;
}


function build_searchtypeform() {  
	return drupal_get_form('searchtypeform');
}

function searchtypeform_validate($form, $form_state){
	$name = $form_state['values']['name'];
	$distance = $form_state['values']['distance'];
	$threshold = $form_state['values']['threshold'];
	
	if (strlen($name) < 4) form_set_error('', t('The minimum lenght allowed for name is 4 characters.'));
	if (!ereg("^[a-zA-Z0-9\-_ ]{4,20}$", $name)) form_set_error('', t('Change name according to allowed characters: _;a-z;A-Z;0-9; ;.'));
		
	
	
}

function searchtypeform_submit($form, $form_state){	
	$name = $form_state['values']['name'];
	$threshold = $form_state['values']['threshold'];
	$distance = $form_state['values']['distance'];
	$type = 'taxonomy';
	$subtree = $form_state['values']['subtree'];
	
	
	$query = db_query("INSERT INTO similar_ideas_searchtypes (name,type,distance,threshold,taxonomy_subtree) VALUES ('".$name."','".$type."',".$distance.",".$threshold.",'".$subtree."')");
	
}



//Form with the elements for the add field form.
function mixedsearchtypeform($form_state){	
	
	$options = array();
	$query = db_query("SELECT * FROM similar_ideas_searchtypes WHERE type='taxonomy' OR type='full-text'");
	while($r = db_fetch_object($query)){
		$options[$r->id]= $r->name;
	}
	
	
	
	$form['name'] = array(
	  '#type' => 'textfield',	 
	  '#title' => t('Search Name'),
	  '#default_value' => '',	  	
	  '#size' => 25,
	  '#maxlength' => 25,
	  '#suffix' => "<br>",
	  '#description' => t('Allowed characters: _;a-z;A-Z;0-9. Min Lenght: 4'),
	  '#required' => TRUE,
	);
	
    $form['mixed_search_type'] = array(
      '#type' => 'radios', 
	  '#description' => t('Indicates how the search results are merged. "OR" type means that the final result list is a sum similar nodes detected by any of mixed result lists, "AND" type means an element will shown on the final list only if it is present on every single mixed search type result list'),
      '#title' => t('Mixed search type'), 
      '#default_value' => 0, 
      '#options' => array(t('OR'), t('AND')),
    );
	
	
	$form['searches'] = array(
		 '#prefix' => "<br>",
		 '#sufix' => "",
		 '#type' => 'select',		 
		 '#title' => t("Taxonomy Subtree"),
		 '#multiple' => TRUE,
		 '#default_value' => 'none',
		 '#options' => $options,
		 '#size' => 7,
		 '#required' => TRUE,
		);
	
	$form['save'] = array(
		  '#type' => 'submit',	   
		  '#value' => t('Add similarity type'),	  
	);
	return $form;
}


function build_mixedsearchtypeform() {  
	return drupal_get_form('mixedsearchtypeform');
}

function mixedsearchtypeform_validate($form, $form_state){
	$name = $form_state['values']['name'];		
	if (strlen($name) < 4) form_set_error('', t('The minimum lenght allowed for name is 4 characters.'));
	if (!ereg("^[a-zA-Z0-9\-_ ]{4,20}$", $name)) form_set_error('', t('Change name according to allowed characters: _;a-z;A-Z;0-9; ;.'));
}

function mixedsearchtypeform_submit($form, $form_state){	
	$name = $form_state['values']['name'];	
	$searches = $form_state['values']['searches'];
	foreach($searches as $search){
		$ss .= $search."_";
	}
	
	if ($form_state['values']['mixed_search_type']==1) $type = 'mixed_and'; else $type = 'mixed';
	
	$query = db_query("INSERT INTO similar_ideas_searchtypes (name,type,distance,threshold,taxonomy_subtree) VALUES ('".$name."','".$type."',0,0,'".$ss."')");
	
}


//Content for editing search type %id
function similar_ideas_editsearch($id) {
	global $base_path;
	
	if (is_numeric($id) && $id > 1){
		$result = db_query("SELECT * FROM similar_ideas_searchtypes WHERE id=".$id);
		$data = db_fetch_object($result);
		if ($data){			
			$content .= build_editform($id,$data);
		}else{
			$content .= t("This is not a valid ID.")."<br>";
			$content .= "Please select a proper one in the <a href='".$base_path."?q=admin/settings/similar_ideas/searchtypes'>administration page</a>";	
		}
	}else {
			$content .= "This is not a valid ID.<br>";
			$content .= "Please select a proper one in the <a href='".$base_path."?q=admin/settings/similar_ideas/searchtypes'>administration page</a>";		
	}
	return $content;
}

//Form to confirm edit Search type
function editform($form_state,$id,$default){	
	
	$subtree = taxonomy_get_vocabularies($type = 'idea');
	$options = array();
	$options['all'] = t('All Vocabularies');
	foreach ($subtree as $voc){
		$options[$voc->vid]= $voc->name;
	}

	$form['name'] = array(
	  '#type' => 'textfield',	 
	  '#title' => 'Search Name',
	  '#default_value' => $default->name,	  	
	  '#size' => 25,
	  '#maxlength' => 25,
	  '#suffix' => "<br>",
	  '#description' => 'Allowed characters: _;a-z;A-Z;0-9. Min Lenght: 4 ',
	  '#required' => TRUE,
	);
	$form['type'] = array(
		 '#prefix' => "",
		 '#sufix' => "</ul>",
		 '#type' => 'select',		 
		 '#title' => "<ul>Type",
		 '#default_value' => $default->type,
		 '#options' => array('none' => '--Select type--', 'taxonomy' => 'Taxonomy Search', 'mixed' => 'Mixed Search'),	
		 '#required' => TRUE,
		);
	$form['distance'] = array(
		 '#prefix' => "",
		 '#sufix' => "</ul>",
		 '#type' => 'select',		 
		 '#title' => "<ul>Distance",
		 '#default_value' => $default->distance,
		 '#options' => array(0 => 0,1 => 1,2 => 2,3 => 3,4 => 4,5 => 5,6 => 6,7 => 7,8 => 8,9 => 9),	
		 '#required' => TRUE,
		);	
	$form['threshold'] = array(
		 '#prefix' => "",
		 '#sufix' => "</ul>",
		 '#type' => 'select',		 
		 '#title' => "<ul>Threshold",
		 '#default_value' => $default->threshold,
		'#options' => array(1 => "10%",2 => "20%",3 => "30%",4 => "40%",5 => "50%",6 => "60%",7 => "70%",8 => "80%",9 => "90%",10 => "100%"),	
		 '#required' => TRUE,
		);	
	$form['subtree'] = array(
		 '#prefix' => "<br>",
		 '#sufix' => "",
		 '#type' => 'select',		 
		 '#title' => "Taxonomy Subtree",
		 '#multiple' => FALSE,
		 '#default_value' => $default->taxonomy_subtree,
		 '#options' => 	$options,
		 '#size' => 7,
		 '#required' => FALSE,
		);
	$form['save'] = array(
		  '#type' => 'submit',	   
		  '#value' => 'Save',	  
	);	
	$form['cancel'] = array(
	  '#type' => 'button',
	  '#value' => 'Cancel',	  
	  '#executes_submit_callback' => TRUE,
	  '#submit' => array('editsearch_cancel'),
	);	
	return $form;
}


function build_editform($id,$default) {	
	return drupal_get_form('editform',$id,$default);
}


function editform_submit($form, $form_state){
	$id = $form['#parameters']['2'];	
	
	$name = $form_state['values']['name'];
	$distance = $form_state['values']['distance'];
	$type = $form_state['values']['type'];	
	$subtree = $form_state['values']['subtree'];
	$threshold = $form_state['values']['threshold'];
	
	$query = db_query("UPDATE similar_ideas_searchtypes SET name='".$name."', type='".$type."', distance=".$distance.", threshold=".$threshold.", taxonomy_subtree='".$subtree."' WHERE id=".$id);
	
	drupal_get_messages();
	drupal_set_message("Similarity type properly edited.");
	drupal_goto("admin/settings/similar_ideas/searchtypes");
}


function editsearch_cancel($form) {	
	drupal_get_messages();
	drupal_goto("admin/settings/similar_ideas/searchtypes");
}


//Content for deleting search type %id
function similar_ideas_deletesearch($id) {	
	$query = db_query("DELETE FROM similar_ideas_searchtypes WHERE id=".$id);
	drupal_get_messages();
	drupal_set_message("Deleted properly.");
	drupal_goto("admin/settings/similar_ideas/searchtypes");
}

//Content for deleting relation type field 
function similar_ideas_deletefield($type) {	
	$fields = get_relation_fields();
	$i = array_search($type,$fields);
	if ($fields[$i] == $type){	
		$field = substr($type, 15);
		$query = db_query("DELETE FROM similar_ideas_history WHERE relationship_type='".$field."'");
		$query2 = db_query("DELETE FROM similar_ideas_relations WHERE relationship_type='".$field."'");
		
		
		$query_sel = db_query ("SELECT * FROM similar_ideas_relationtypes WHERE name='".$type."'");
		$data = db_fetch_object($query_sel);
		//If relationship have inverse we delete it.
		if ($data->inverse != "none" && $data->symetric == 0){			
			$query_sel2 = db_query ("SELECT * FROM similar_ideas_relationtypes WHERE name='".$data->inverse."'");
			$data2 = db_fetch_object($query_sel2);
			$query_update = db_query("UPDATE similar_ideas_relationtypes SET inverse='none' WHERE name='".$data2->name."'");			
		}
		
		$query3= db_query("DELETE FROM similar_ideas_relationtypes WHERE name='".$type."'");
		include_once(drupal_get_path('module', 'content') .'/includes/content.crud.inc');
		content_field_instance_delete($type, 'idea');
		
		drupal_get_messages();
		drupal_set_message("Field Deleted properly.");
		drupal_goto("admin/settings/similar_ideas/relations");
	}else{
		drupal_get_messages();
		drupal_set_message("You are trying to delete a non existing field.",'error');
		drupal_goto("admin/settings/similar_ideas/relations");
	}
}

//Content for deleting relation type field 
function similar_ideas_editfield($id) {	
	global $base_path;
	
	if (is_numeric($id) && $id >= 1){
		$result = db_query("SELECT * FROM similar_ideas_relationtypes WHERE id=".$id);
		$data = db_fetch_object($result);
		if ($data){			
			$content .= build_editFieldform($data);
		}else{
			$content .= t("This is not a valid ID.")."<br>";
			$content .= "Please select a proper one in the <a href='".$base_path."?q=admin/settings/similar_ideas/relations'>administration page</a>";	
		}
	}else {
			$content .= t("This is not a valid ID")."<br>";
			$content .= "Please select a proper one in the <a href='".$base_path."?q=admin/settings/similar_ideas/relations'>administration page</a>";		
	}
	return $content;
}

//Form to confirm edit field type
function editFieldform($form_state,$data){	
	$options['none'] = 'No Inverse';
	
	$result = db_query("SELECT * FROM similar_ideas_relationtypes");	
	while ($datas = db_fetch_object($result)){ 
		if ($data->name != $datas->name) //We delete current relation for possible inverse options
			$options[$datas->name] = ucfirst(substr($datas->name,15));
	}
	
	$form['name'] = array(
	  '#type' => 'textfield',	 
	  '#title' => 'Relationship name',
	  '#default_value' => substr($data->name,15),	  	
	  '#size' => 20,
	  '#maxlength' => 25,
	  '#suffix' => "<br>",
	  '#disabled' => TRUE,	  
	);
	$form['symetric'] = array(
	  '#prefix' => '',
  	  '#type' => 'checkbox',
  	  '#title' => t('Set symetric relationships'),
	  '#description' => t('If enabled, for every relationship added, both ideas involved will have the relationship.'),
	  '#return_value' => '1',
	  '#default_value' => $data->symetric,
	);	
	$form['inverse'] = array(
		 '#prefix' => "",
		 '#sufix' => "",
		 '#type' => 'select',		 
		 '#title' => "Inverse Relationship",
		 '#multiple' => FALSE,	
		 '#default_value' => $data->inverse,		 
		 '#options' => 	$options,
		 '#size' => 7,
		 '#required' => FALSE,
	);
	$form['save'] = array(
		  '#type' => 'submit',	   
		  '#value' => 'Edit',	  
	);
	$form['cancel'] = array(
		  '#type' => 'button',	   
		  '#value' => 'Cancel',	
		  '#executes_submit_callback' => TRUE,
		  '#submit' => array('editFieldform_cancel'),		  
	);
	return $form;
	
	
}


function build_editFieldform($data) {	
	return drupal_get_form('editFieldform',$data);
}

function editFieldform_validate($form, $form_state){
	/* $name = $form_state['values']['name'];
	if (strlen($name) < 4) form_set_error('', 'The minimum lenght allowed is 4 characters.');
	if (!ereg("^[a-zA-Z0-9\-_]{4,20}$", $name)) form_set_error('', 'Change name according to allowed characters: _;a-z;A-Z;0-9.');
	
	
	$fields = get_relation_fields();
	foreach ($fields as $field){
		if (strtolower($name) == substr($field, 15)) form_set_error('', 'This name is already used as a relationship type, please use a different one.');;
	} */
}
function editFieldform_cancel($form) {	
	drupal_get_messages();
	drupal_goto("admin/settings/similar_ideas/relations");
}
function editFieldform_submit($form, $form_state){

	$data = $form['#parameters']['2'];	
	//$previous_name = $data->name;
	
	//module_load_include('inc', 'content', 'includes/content.crud');
	//$field = content_fields($previous_name, 'idea');
	//$name =strtolower($form_state['values']['name']);
	//$field['field_name'] = $name;
	//content_field_instance_update($field);
	
	$symetric = $form_state['values']['symetric'];
	if($symetric == 1) {
		$inverse = $data->name;
	}else{
		$symetric = 0;
		$inverse = $form_state['values']['inverse'];
		if ($inverse != 'none'){//Update previous relation to set the new one as inverse.
			$query = db_query("UPDATE similar_ideas_relationtypes SET inverse='".$field['field_name']."' WHERE name='".$inverse."'");
		}
	}
	
	$query = db_query("UPDATE similar_ideas_relationtypes SET symetric=".$symetric.", inverse='".$inverse."' WHERE id=".$data->id);
	
	drupal_goto("admin/settings/similar_ideas/relations");
}
