<?php
//v 2.0.2

//For a list of taxonomy terms it returns all terms of the taxonomy tree with distance lower than the given ones. 
function similar_ideas_getDistanceTerms($terms, $distance,$vid) {		
	$all_terms = array();
	//var_dump($terms);
	
	if (is_array($terms)){
		foreach ($terms as $term){
			$new_terms = array(); 
			$new_terms = similar_ideas_getSingleDistanceTerm($term, $distance, $vid);
			$all_terms = array_merge($all_terms, $new_terms);
		}	
	}
	return $all_terms;
}


//For one taxonomy term it returns all terms of the taxonomy tree with distance lower than the given one. 
//Algorithm:
// 1. We extract children + parent of the term.
// 2. We do 1. for the new terms. 
// 3. Repeat 2, N times. N=distance.
function similar_ideas_getSingleDistanceTerm($term, $distance, $vid) {		
	$all_terms = array(); //All founded terms for $distance
	$all_terms[$term] = $term;
	$buffer = array(); //The new terms we need to proccess in every loop.
	$buffer[] = $term;
	$current_distance = 0;
	$flag = TRUE; //Boolean to get first taxonomy childrens if parent term reached.
	
	while ($current_distance < $distance){
		$buffer2 = array(); //Local array destroy in every loop
		foreach($buffer as $item){
		
			$childrens = taxonomy_get_children($item); //Get Childrens
			$par=intval(array_pop(taxonomy_get_parents($item))->tid); //Get parents
			
			foreach ($childrens as $child) {
				$all_terms[intval($child->tid)]=intval($child->tid); // [tid] = tid;
				$buffer2[intval($child->tid)]=intval($child->tid); // [tid] = tid;
			}
			
			
			if ($par != 0){ //First item of the taxonomy is tid 0. We include this condition to avoid other vocabularies terms.
				$all_terms[$par] = $par; // [tid] = tid;
				$buffer2[$par] = $par; // [tid] = tid;
			}else{ //In case we are in the parent term (tid 0) We extract the first items of the tree.
				if($flag){
					$children_top = taxonomy_get_children(0, $vid, $key = 'tid');
					foreach ($children_top as $child_top) {
						$all_terms[intval($child_top->tid)]=intval($child_top->tid); // [tid] = tid;
						$buffer2[intval($child_top->tid)]=intval($child_top->tid); // [tid] = tid;
					}
					$flag = FALSE;
				}
			}
			
		}
		$buffer = array();
		$buffer = $buffer2;		
		$current_distance++;	
	}
	return $all_terms;
}



