<?php
//v 2.0.2


//Similar ideas main page. Suggestions after creating one idea
function similar_ideas_page($node_id, $type) {
	global $base_path;	
	$nid = $node_id;
	$node_path = $base_path."?q=similar_ideas/".$nid."/";
	$node = node_load($nid, NULL, TRUE);
	
	if ($node) {		
			
			//If relations exist we skip or not the similarities page(according to config checkbox setting)
			$aftereditconfig = variable_get('similar_ideas_afteredit', '1');
			$aftercreateconfig = variable_get('similar_ideas_aftercreate', '1');
			
			if ($aftercreateconfig != 1){ //We skip similarity page if after-create setting disabled
				drupal_goto("node/".$nid);
			}
			if ($aftereditconfig != 1){ //We skip similarity page if after-edit setting disabled
				$actualrels = viewnoderel($node); //Extracting all the relationship of the node
				if ($actualrels) drupal_goto("node/".$nid);
			}
			
			//Page content
			$content = "<div><p><span class='bold'><strong>Title:</strong></span> ".$node->title."</p>";			
			$summary = getSummary($node);			
			$content .= "<p><span class='bold'><strong>Idea Summary:</strong></span> ".$summary."</p></div>";

			//Check type from search names.
			$searchnames = get_search_names();
			$searchtypes = get_search_typesall();
			
			//Showing terms for that "vocabulary"
			$clave = array_search($type, $searchnames);	
			if($searchnames[$clave] == $type && $searchtypes[$clave][2] == "taxonomy"){					
				foreach ($node->taxonomy as $tax){					
					if ($tax->vid == $searchtypes[$clave][5] || $searchtypes[$clave][5] == 'all'){
						$terms .= $tax->name.", ";	
					}			
				}
				$terms = substr($terms, 0, -2);
				$content .= "<div><p><span class='bold'><strong>Idea Terms:</strong></span> ".$terms."</p></div>";
			}
			
			$content .= "<div class='suggestions'>";
			$content .= "<div class='suggs_header'><h3><strong>Suggestions:</strong></h3></div>";			
			
			
			
			
			if (!$type) $content .= similar_ideas_entity($searchnames[0],$searchtypes[0][2],$nid, $node_path, 0);
			else if($searchnames[$clave] == $type) $content .= similar_ideas_entity($searchnames[$clave],$searchtypes[$clave][2],$nid, $node_path,$clave);
			//else if($searchnames[$clave] == $type && $searchtypes[$clave][2] == "mixed") $content .= similar_ideas_mixed($clave,$nid);
			else {
				$content .= "<div class='error_type'><span class='bold'>[Error]</span>";
				$content .= "You must specify a correct search type.</div>";
				$error = true;
			}
			$content .= "</div>";			
			
	} else {
		$content = "<div class='error_idea'><span class='bold'>[Error]</span><br/>";
		$content .= "You must specify a valid idea.</div>";
	}
	return $content;
}

//Function to get similarity results for mixed search
//@param $clave search type name
//@param $nid nid of the node that is being investigated
//@param $type type of mixed search (mixed, mixed_or, mixed_and)
function similar_ideas_mixed($clave,$nid, $type = 'mixed_or'){
	$query = db_query("SELECT * FROM similar_ideas_searchtypes WHERE name='".$clave."'");
	$result = db_fetch_object($query);
	
	$tax_searches = $result->taxonomy_subtree; //IDs of searches types involved separated by _ (Example: 2_4_5_)
	$array_searches = preg_split("/_/",$tax_searches); //Array with IDs 
	$items = array();
	$result_lists = array();
	
	//Take all results from the searches involved
	
	foreach ($array_searches as $search){
		if ($search > 0){ //To avoid the last item of the array which is empty ""
			$query = db_query("SELECT * FROM similar_ideas_searchtypes WHERE id=".$search);
			$result = db_fetch_object($query);
			
			if ($result->type == 'taxonomy'){				
				$array = similar_ideas_luceneapi($nid, TRUE, $result->distance, $result->threshold, $result->taxonomy_subtree);
			}else{
				$array = similar_ideas_luceneapi($nid, FALSE);
			}
			//$items = array_merge($array,$items);
			$result_lists[] = $array;
		}
	}
	
	// Merge result lists from search types: the merge algorithm depends on thé mixed search type 
	// "mixed" and "mixed_or" are the same: we merge all results getting only the top N ordered by score. 
	$hits = array();
	if ($type == 'mixed' || $type == 'mixed_or') {
		//merge all results into single list
		foreach ($result_lists as $result_list) 
			$items = array_merge($result_list,$items);
		//iterate over results to eliminate duplicates (items that were find twice or more by different search types)
		foreach ($items as $item){
			if (!$hits[$item['node']] > 0){
				$hits[$item['node']] = $item['score'];
			}else if ($item['score'] > $hits[$item['node']]){
				$hits[$item['node']] = $item['score'];
			}
		}
	} else // "mixed_and" : we select only those ideas that are present on every list
	{
		if (count($result_lists)>0)
		{
			$items = array_shift($result_lists); //remove the first result list and start with it as result list
			//check for every element of the result list from the initial array exist also in other result lists
			foreach ($items as $item)
			{
				$hits[$item['node']] = $item['score']; //by default put the item in the hit list
				
				//check all other result lists
				foreach($result_lists as $result_list)
				{
					$item_status_local = FALSE; //indicates if the item is located on the currently analysed list
					$item_score_local = 0;
					foreach($result_list as $result_list_item) //iterate over all list items
					{
						if ($result_list_item['node'] == $item['node'])
						{
							$item_status_local = TRUE; //set flag to true and break loop for the current list
							$item_score_local = $result_list_item['score'];
							break;
						}
					}
					if ($item_status_local == FALSE) //if the item did not exist in the list, remove it from hit list and skip to next list element
					{
						unset($hits[$item['node']]);
						break;
					} else //otherwise average the score between the previous hits and the currently found one
						$hits[$item['node']] = ($hits[$item['node']] + $item_score_local) / 2;
				}	
			}
		}
	}
	
	
	//sort the list according to the rating
	
	$bool = arsort($hits);
	
	$hits = array_keys($hits);
	
	foreach($hits as $hit){
		$node = node_load($hit);
		$items_final[] = array('node'=>strval($hit),'title'=>$node->title,'url'=>url('node/'. $node->nid, array('absolute' => TRUE)));
	}
	
	
	$length = variable_get('similar_ideas_ndisplayed', 5);
	if ($items_final)
		$items_final = array_slice($items_final, 0, $length);
	else $items_final = array();
	
	return $items_final;
}


//Function to get similarity results
function similar_ideas_entity($searchname,$searchtype,$nid, $node_path,$clave) {	
	$types = get_search_typesall();
	
	foreach ($types as $type){
		if ($type[2] == 'full-text') $items[] = similar_ideas_luceneapi($nid, FALSE);
		if ($type[2] == 'taxonomy') $items[] = similar_ideas_luceneapi($nid, TRUE, $type[3], $type[4],$type[5]);
		if ($type[2] == 'mixed' || $type[2] == 'mixed_or' || $type[2] == 'mixed_and') $items[] = similar_ideas_mixed($type[1],$nid,$type[2]);
	}
	
	
	$content .= "<div class='rel_types'>[ ";
		
	$names = get_search_names();	
	$ntypes = 0;
	$type_selected = 0; //Number of the selected type. Will be an index for $items[index]
	$flag = 1; //boolean for type = none, and "bold" in navigation bar
	$all_empty = 1; //boolean: 1 = every similarity types have 0 matches. 0 = matches found for at least 1 similarity type (used for skipping page...)
	
	//Construction of the relationships-navigation bar 
	foreach ($names as $name){
			
		$end = " | ";
		if (($ntypes+1) % 4 == 0) $end = " ]";
		if (($ntypes % 4 == 0) && ($ntypes > 0)) $content .= "<br>[ "; // We make the navigation bar with a max. of 4 elements per line.
		
		$nameinminus = strtolower($name);
		if ($name == $searchname || ($searchname == 'none' && $flag == 1)){
			$pre = "";
			$post = "";
			$flag = 0;
			$type_selected = $ntypes;
		}else{			
			$pre = "<a href='".$node_path.$nameinminus."'>";
			$post = "</a>";
		}
		
		if (sizeof($items[$ntypes]) > 0) $all_empty = 0; //We set $all_empty = 0 if theres no matches for any similarity type.
		
		
		$number = " (".sizeof($items[$ntypes]).")";
		if ($ntypes == sizeof($names)-1) $end = " ]";
		$content .= $pre.ucfirst($name)." Search".$number.$post.$end;
		$ntypes++;
		
	}
	$content .= "</div>";
	
	
	
	if ($all_empty == 1) drupal_goto("node/".$nid);	//We 'skip' these page if no similarities found in any category.
		
	
	drupal_set_message("We have detected some ideas similar to yours! Please help us keep the system in order and mark the relationships.",'status',false);		
	$content .= build_form($items[$type_selected], $nid,$clave); //Call to the form. This form have the Similar Ideas + Comboboxes + Buttons.
	return $content;
}




function build_form($items, $nid,$key) {  
	return drupal_get_form('similarideas',$items, $nid,$key);
}

//Generates a form with N-items 
//Every item is one of the similar ideas detected by the LuceneAPI
//For every item one ComboBox is displayed to introduce relationships, the title of the ComboBox is the name+link for the Similar Idea detected.
function similarideas($form_state, $items, $nid,$key){
	$form = array();
	
	$node = node_load($nid);
	$actualrels = viewnoderel($node); //Extracting all the relationship of the node
	
	$options = get_array_options(TRUE);	 //function inside similar_ideas.module
		
	if($items != NULL){
		$item_count = count($items);
		$current_item_count = 1;
		foreach ($items as $item) {
			if ($actualrels[$item['node']] != NULL) $defaultvalue = $actualrels[$item['node']];
			else $defaultvalue = '';
			
			$node = node_load($item['node']);
			$title = $node->title;
			$summary = getSummary($node);
			$author = $node->name;
			$created = format_date($node->created);
			
			//We get for each idea its terms to show on the combo description.
			$searchtypes = get_search_typesall();
			$terms = "";
			foreach ($node->taxonomy as $tax){					
				if ($tax->vid == $searchtypes[$key][5] || $searchtypes[$key][5] == 'all'){
					$terms .= $tax->name.", ";	
				}			
			}
			$terms = substr($terms, 0, -2);	
			$text = "<a class='tooltip' href='".$item["url"]."'>".strip_tags($item["title"])."<span class='custom info'><em>".strip_tags($title)."</em>".$summary."<br><strong>Author:</strong> ".$author."<br><strong>Created:</strong> ".$created."</span></a>";
			
			if ($current_item_count == 1) //if first item start html list
				$html_prefix = "<ul class=\"similar_ideas_suggestion_list\"><li>"; else $html_prefix = "<li>";
			
			if ($current_item_count == $item_count) //if final item close html list tag
				$html_suffix = "</li></ul>"; else $html_suffix = "</li>";
			
			$form[$item["node"]] = array(
			 '#prefix' => $html_prefix,
			 '#suffix' => $html_suffix,
			 '#type' => 'select',		 
			 '#title' => $text,		 
			 '#default_value' => $defaultvalue,
			 '#options' => $options,
			 '#description' => $terms,
			);
			$current_item_count++;	
		}	
	}
	$form['save'] = array(
	  '#type' => 'submit',	   
	  '#value' => 'Save relationships',
	  '#attributes' => array( 'title' => t('Save the selected relationships for this idea')),
	);
	
	$form['slash'] = array(
	  '#value' => "<style type='text/css'>.sep{margin-left:5px; margin-right:5px;}</style><span class='sep'><strong> | </strong></span>",
	);
	
	$form['edit'] = array(
		  '#type' => 'button',
	  '#value' => 'Rewrite Your Idea',
	  '#attributes' => array( 'title' => t('Go back to your idea edit screen and rewrite its text')),	  
	  '#executes_submit_callback' => TRUE,
	  '#submit' => array('similarideas_edit'),
	);
	
	$form['delete'] = array(
		  '#type' => 'button',
	  '#value' => 'Cancel Your Idea',
	  '#attributes' => array( 'title' => t('Cancel and fully delete your idea')),	  
	  '#executes_submit_callback' => TRUE,
	  '#submit' => array('similarideas_delete'),
	);
	return $form;
}

//Action for edit button 
function similarideas_edit($form) {	
	drupal_get_messages();
	$nid = $form['#parameters']['3'];		
	drupal_goto("node/".$nid."/edit");
}
//Action for delete button 
function similarideas_delete($form) {	
	drupal_get_messages();
	$nid = $form['#parameters']['3'];
	drupal_goto("node/".$nid."/delete");
}


//Storing in the DB: Relations stored in BOTH ideas!!
function similarideas_submit($form, $form_state) {	
	$nid = $form['#parameters']['3'];
	$items = $form['#parameters']['2'];	

	$node = node_load($nid);
	$actualrels = viewnoderel($node); //Extracting all the relationship of the node
	
	$permission = user_access('post relationships without approval', NULL, FALSE);
		
	$node1_origin_change = FALSE;
	
	foreach ($items as $item) {		
	
		$relationship = $form_state['values'][$item['node']];
		$destiny_idea = $item['node'];
		
		$node2_destiny_change = FALSE;
		
		//Boolean to know if we are going to add relationship in both ideas or just in the current one.
		$q_inverse = db_query("SELECT inverse FROM similar_ideas_relationtypes WHERE name='".$relationship."'");
		$result = db_fetch_array($q_inverse);  	
		$inverse = $result['inverse'];
		if($inverse !='none' && $result){
			$inverse = TRUE;
			$inverse_rel = $result['inverse'];
		}else $inverse = FALSE;
		
		$node2 = node_load($destiny_idea);
		
		
		$alreadystored = false;		//boolean to avoid the pending-NONE if relation = new.	
		//Checking for duplicates entrys and remove them.
		if ($actualrels[$destiny_idea]){	
			$alreadystored = true;
			if($permission){ //User can unset relationships without aproval
				//check if the relationship was changed at all and proceed with erasing the previous one only if there is a change
				if ($actualrels[$destiny_idea]!=$relationship)
				{
					//Removing from actual node.
					$field = $node->$actualrels[$destiny_idea];				
					$key = array_search(array('nid' => $destiny_idea), $field);
					unset($field[$key]);
					$node->$actualrels[$destiny_idea] = $field;
					$node1_origin_change = TRUE;
					
					//Removing from destiny node.
					//Checking if current relation have inverse relation
					$q_inverse2 = db_query("SELECT inverse FROM similar_ideas_relationtypes WHERE name='".$actualrels[$destiny_idea]."'");
					$result2 = db_fetch_array($q_inverse2);  	
					$inverse2 = $result2['inverse'];
					if($inverse2 !='none' && $result2){
						$inverse2 = TRUE;
						$inverse_rel2 = $result2['inverse'];
					}else $inverse2 = FALSE;
					
					//If inverse relation exists...
					if ($inverse2){						
						$field = $node2->$inverse_rel2;		
						$key = array_search(array('nid' => $nid), $field);
						unset($field[$key]);
						$node2->$inverse_rel2 = $field;
						$node2_destiny_change = TRUE;
					}
				}
			}

		}		
		//Storing the new relationships.
		global $user;			
		$status = "pending";					
		$author = $user->name;
		$reviewer = "NONE";
		$date = time();
		$relation = "NONE";		
		if ($relationship){ // 0 = --Set Relationship-- So nothing to store...
			
			$relation = substr($relationship, 15);

			if($permission){ //User can set relationships without aproval
				if ($actualrels[$destiny_idea]!=$relationship) { //check if the relationship was changed at all and proceed with setting new one only if there was a change
					$field = $node->$relationship;
					$field[]=array('nid' => $destiny_idea);			
					$node->$relationship = $field;
					$node1_origin_change = TRUE;
					
					if($inverse){
						$field = $node2->$inverse_rel;
						$field[]=array('nid' => $nid);	
						$node2->$inverse_rel = $field;
						$node2_destiny_change = TRUE;
					}
				}
			}						
		}	
		if ($alreadystored && $relation == substr($actualrels[$destiny_idea],15)){ //Relation already stored(approved) introduced
			$reviewer = $author;	
			$status = "same-checked"; //Same Relation introduced.
		}	
		if (!$alreadystored && $relation == "NONE"){//New NONE Relation introduced.
			$reviewer = $author;			
			$status = "none-checked"; 
		}
		if($permission) {
			$reviewer = $author;
			$status="approved";	
		}
		
		/*
		 *Checking former pending ideas.
		 */
		$idea1 = $nid;
		$idea2 = $node2->nid;
		//Updating status if relation exists...
		$result = db_query("SELECT id FROM similar_ideas_history WHERE status='pending' AND (idea1=".$idea1." AND idea2=".$idea2.")");
		$value = db_fetch_array($result);  		
		if ($value['id']) $update = db_query("UPDATE similar_ideas_history SET status='auto-checked', reviewer='".$author."' WHERE id=".$value['id']);
		
		//Inserting new data inside history table
		$result1 = db_query("INSERT INTO  similar_ideas_history (idea1,idea2,relationship_type,author,date,status,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."',".$date.",'".$status."','".$reviewer."')");
		
		
		/*
		 *Checking for current_rels ideas
		 */
		if ($status != 'pending') $status = 'approved';
		//if($permission){
			$result2 = db_query("SELECT id FROM similar_ideas_relations WHERE idea1=".$idea1." AND idea2=".$idea2);
			$value2 = db_fetch_array($result2);
			if ($value2) {
				if($relation !='NONE'){
					$update1 = db_query("UPDATE similar_ideas_relations SET idea1=".$idea1.", idea2=".$idea2.", date=".$date.", status='".$status."', reviewer='".$reviewer."', author='".$author."', relationship_type='".$relation."' WHERE id=".$value2['id']);
				}else{
					$result2 = db_query("DELETE FROM  similar_ideas_relations WHERE idea1=".$idea1." AND idea2=".$idea2);
				}
			}else{
				if($relation !='NONE') $insert2 = db_query("INSERT INTO  similar_ideas_relations (idea1,idea2,relationship_type,author,status,date,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."','".$status."',".$date.",'".$reviewer."')");
			}
		//}

		if ($node2_destiny_change) node_save($node2);		
	}
	if ($node1_origin_change) node_save($node);
	drupal_get_messages();	//To remove the 'We have detected some ideas...' message.
	if(!$permission) drupal_set_message("Thank you for your help, your relationships will be queued for aproval.");
	drupal_goto("node/".$nid);
}


//After loading a node calling to this function will return an array with every relations for this node.
//['noderelatedto'] = 'typeofrelation'  (typeofrelation: field_relation_duplicate...)
function viewnoderel($node){	
	$fields = get_relation_fields();
	$out = array();	
	foreach ($fields as $field){
		$stored = $node->$field;
		if($stored){
			foreach ($stored as $store){
				if ($store['nid'] != NULL)	$out[$store['nid']] = $field;
			}
		}
	}
	return $out;	
}
