<?php
//v 2.0.2


//Relationships panel page. Sumarizes all relationships between ideas.
function similar_ideas_panel($node_id, $type) {
	global $base_path;
	
	$nid = $node_id;
	$node_path = $base_path."?q=node/".$nid."/similar_ideas";
	$node = node_load($nid, NULL, TRUE);
	if ($node) {	
			
			//Calculate number of items for each relationships
			$nrel = array();
			
			$fields = get_relation_fields();
			$names = array();
			foreach ($fields as $field){
				$key = substr($field, 15);
				$nrel[$key] = similar_ideas_relationship_count($nid, $field);
				$names[] = $key;
			}
			
			$content = "<div class='relations'>";	
			
			
			if (array_search($type, $names)) $content .= similar_ideas_relationship($nid, $node_path, ucfirst($type), "field_relation_".$type, $nrel);
			else $content .= similar_ideas_relationship($nid, $node_path, ucfirst($names[0]), "field_relation_".$names[0], $nrel);
	
			$content .= "</div>";
	
			
	} else {
		$content = "<div class='error_idea'><span class='bold'>[Error]</span><br/>";
		$content .= "You must specify a valid idea node ID.</div>";
	}
	return $content;
}

//Counter for each type of relationship.
function similar_ideas_relationship_count($nid, $field) {
	$nrel = 0;
	$nd = node_load($nid);	
	$relations = $nd->$field;	
	if ($relations){
		foreach ($relations as $rel){	
			$id = $rel['nid'];	
			if ($id){
				$nrel++;
			}
		}
	}
	return $nrel;
}

//Navigation bar in the similar ideas panel
function similar_ideas_relationship($nid, $node_path, $relation, $field, $nrel) {
	

	$content .= "<div align='center' class='rel_types'><strong>| </strong>";
		
	$names = get_relation_names();
	
	$ntypes = 0;
	//Construction of the relationships-navigation bar 
	foreach ($names as $name){
		if (($ntypes % 4 == 0) && ($ntypes > 0)) $content .= "<br><strong>| </strong>"; // We make the navigation bar with a max. of 4 elements per line.	
		$nameinminus = strtolower($name);
		if ($name == $relation){
			$pre = "";
			$post = "";
		}else{			
			$pre = "<a href='".$node_path."/".$nameinminus."'>";
			$post = "</a>";
		}
		$content .= $pre.$name." Ideas (".$nrel[$nameinminus].")".$post." <strong>|</strong> ";
		$ntypes++;
		
	}
	$content .= "</div>";
	
	//CURRENT RELATIONS	
	$content .= "<br><div class='similar'><h3><strong>".$relation." Ideas:</strong></h3>";
	$content .= extract_similar_ideas($nid,$field); //Content with the list of similar ideas.
	
	//PENDING RELATIONS
	$permission = user_access('approve relationships', NULL, FALSE);	
	if ($permission) $content .= getPendingRelations($nid);
	$content .= "</div><br>";
	return $content;
}

//Content for pending relations;
function getPendingRelations($nid){
	
	//Creating array, every row is a pending relationship		
	$resultpending = db_query("SELECT * FROM similar_ideas_history WHERE status='pending' AND (idea1=".$nid." OR idea2=".$nid.") ORDER BY date DESC");
	$pending_array = array();		
	while($value = db_fetch_array($resultpending)) {
  		$pending_array[] = $value;
	}
	//Display pending relationships: 
	$rows = array();
	$imgok = theme_image(drupal_get_path('module', 'similar_ideas') . "/gi2mo_tooltip/greentick.png");
	$imgcross = theme_image(drupal_get_path('module', 'similar_ideas') . "/gi2mo_tooltip/redcross.png");
	foreach ($pending_array as $row){
		$rel_id = $row['id'];
		$idea1 = $row['idea1'];
		$idea2 = $row['idea2'];
		$relation = ucfirst($row['relationship_type']);		
		$statustitle = "Suggested by:</strong> ".$row['author'];
		$date = format_date($row['date']);		
		$node2load = '';
		if ($idea1 != $nid) $node2load=$idea1;
		else $node2load=$idea2;
 		
		$node = node_load($node2load);
		$id = $node->nid;
		$title = $node->title;
		$summary = getSummary($node);
		$author = $node->name;
		$created = format_date($node->created);
		
		//$idealink ="<a href='".$base_path."?q=node/".$id."'><span class=\"hotspot\" onmouseout='tooltip.hide();' onmouseover=\"tooltip.show('<span class=\'tiptitle\'>".$title."</span><br>".$summary."<br><strong>Author:</strong> ".$author."<br><strong>Created:</strong> ".$created."');\">".$title."</span></a>";
		$idealink = "<a class='tooltip' onMouseOver=\"fade('popup1',true);\" onMouseOut=\"fade('popup1',false);\" href='".$base_path."?q=node/".$id."'>".$title."<span class='custom info' id='popup1'><em>".$title."</em>".$summary."<br><strong>Author:</strong> ".$author."<br><strong>Created:</strong> ".$created."</span></a>";
		
		//$approvelink = "<img src='".$imgok."'/><a href='".$base_path."?q=similar_moderaterel/".$rel_id."/approve'><span class=\"hotspot\" onmouseout='tooltip.hide();' onmouseover=\"tooltip.show('<span class=\'tiptitle\'>".$statustitle."</span><br><strong>Date of suggestion:</strong> ".$date."');\">Approve</span></a>";
		$approvelink = $imgok."<a class='tooltip' onMouseOver=\"fade('popup1',true);\" onMouseOut=\"fade('popup1',false);\" href='".$base_path."?q=similar_moderaterel/".$rel_id."/approve'>Approve<span id='popup1' class='custom info'><em>".$statustitle."</em><strong>Date of suggestion:</strong> ".$date."</span></a>";
		
		$denylink = $imgcross."<a href='".$base_path."?q=similar_moderaterel/".$rel_id."/deny'>Deny approval</a>";
		$rows[] = array($idealink,$relation,$approvelink,$denylink);
	}
	$header = array("Title", "Type of relationship suggested", "","");
	if ($rows){		
		$content .="<br><strong>Pending relationships for approval:</strong>";
		$content .= theme('table', $header, $rows);
	}
	return $content;
}

//Extract ideas relationships and show it on the page
//$node = actual node we are looking its relationships
//$field = field for the selected relationship $field = 'field_relation_duplicate' , 'field_relation_opposite'....
function extract_similar_ideas($node,$field){		
	$nd = node_load($node);	
	
	$relations = $nd->$field;	
	$content = "<div class='suggestions'>";
		
	$typeofrelation = substr($field, 15);
	$content .= build_formpanel($node,$relations,$typeofrelation);
	
	$content.="</div>";

	return $content;
}


//Form with the list of similar ideas, edit relationship combos + save changes.
function build_formpanel($nid, $relations, $typeofrelation) {  
	return drupal_get_form('panelform', $nid,$relations,$typeofrelation);
}
function panelform($form_state, $nid, $relations,$typeofrelation){
	
		
	$perm_edit = user_access('edit relationships', NULL, FALSE);	
	$perm_delete = user_access('delete relationships', NULL, FALSE);	

	
	$imgurl = theme_image(drupal_get_path('module', 'similar_ideas') . "/gi2mo_tooltip/delete.png",'Delete relationship','Delete relationship');
	$listempty = TRUE;
	$form['ul'] = array(
	 '#value' => "<ul class=\"similar_ideas_suggestion_list\">",
	);	
	if($relations){
		foreach ($relations as $rel){		
			$id = $rel['nid'];	
			if ($id){
				$destiny_node = node_load($id);			
				$title = $destiny_node->title;
				$summary = getSummary($destiny_node);
				$author = $destiny_node->name;
				$created = format_date($destiny_node->created);
				
				

				$title = "<a class='tooltip' onMouseOver=\"fade('popup1',true);\" onMouseOut=\"fade('popup1',false);\" href='".$base_path."?q=node/".$id."'>".strip_tags($title)."<span id='popup1' class='custom info'><em>".strip_tags($title)."</em>".$summary."<br><strong>Author:</strong> ".$author."<br><strong>Created:</strong> ".$created."</span></a> ";		
				//for fadein prefix vs title
				//$title ="<li><a href='".$base_path."?q=node/".$id."'><span class=\"hotspot\" onmouseout='tooltip.hide();' onmouseover=\"tooltip.show('<span class=\'tiptitle\'>".$title."</span><br>".$summary."<br><strong>Author:</strong> ".$author."<br><strong>Created:</strong> ".$created."');\">".$title."</span></a>";

				$status = getStatusInfo($nid,$destiny_node->nid);
				$deletion ="";
				if($perm_delete) $deletion = "<a href='".$base_path."?q=similar_deleterel/".$nid."/".$id."/".$typeofrelation."'>".$imgurl."</a>";

				if ($perm_edit){
					$options = get_array_options(TRUE);	 //function inside similar_ideas.module
					$options['']="--Change Relationship--";
					
					
					$form[$id] = array(
					 '#prefix' => '<li>',					 
					 '#suffix' => '</li>',
					 '#type' => 'select',		 
					 '#title' => $title.$status.$deletion,	
					 '#options' => $options,					
					);
					
					
			
				}else{
					$form[$id] = array(
					  '#value' => "<li>".$title.$status.$deletion."</li>",
					);
				}
				$listempty = FALSE;
			
			}else {
				$form[$id] = array(
				  '#value' => "<li><p>No ideas with this relationship</p></li>",
				);
			}	
		}
	}else{
		$form[$id] = array(
		 '#value' => "<li><p>No ideas with this relationship</p></li>",
		);
	}
	$form['ul2'] = array(
	 '#value' => "</ul>",
	);	
	
	
	if ($perm_edit && !$listempty){
		$form['submit'] = array(
		  '#type' => 'submit',	   
		  '#value' => 'Save Changes',	  
		);
	}
	$form['add'] = array(
	  '#type' => 'button',
	  '#value' => 'Add relationship',	  
	  '#executes_submit_callback' => TRUE,
	  '#submit' => array('panel_add'),
	);
	return $form;
}

//Function to get string for the popup of the relationship status.
function getStatusInfo($idea1,$idea2){
	$imginfo = theme_image(drupal_get_path('module', 'similar_ideas') . "/gi2mo_tooltip/greeninfo.png");
	$result = db_query("SELECT * FROM similar_ideas_history WHERE idea1=".$idea1." AND idea2=".$idea2." ORDER BY date DESC");
	$value = db_fetch_array($result);  		
	
	$status = $value['status'];
	$date = format_date($value['date']);
	$reviewer =$value['reviewer'];
	$author = $value['author'];
	$title = "Status: ".$value['status'];
	
	

	$string = "<a class='tooltip' onMouseOver=\"fade('popup1',true);\" onMouseOut=\"fade('popup1',false);\" href='#'>".$imginfo." <span id='popup1' class='custom info'><em>".$title."</em><strong>Suggested by:</strong> ".$author."<br><strong>Approved by:</strong> ".$reviewer."<br><strong>Date of approval:</strong> ".$date."</span></a> ";	
	//$string = "<a href='#'><span class=\"hotspot\" onmouseout='tooltip.hide();' onmouseover=\"tooltip.show('<span class=\'tiptitle\'>".$title."</span><br><strong>Suggested by:</strong> ".$author."<br><strong>Approved by:</strong> ".$reviewer."<br><strong>Date of approval:</strong> ".$date."');\"><img src='".$imginfo."'/></span></a>";

	

	return $string;
}

function panelform_submit($form, $form_state) {
	$nid = $form['#parameters']['2'];
	$relations = $form['#parameters']['3'];	

	$node = node_load($nid);
	$actualrels = viewnoderel($node); //Extracting all the relationship of the node

	$permission = user_access('post relationships without approval', NULL, FALSE);
	
	$node1_origin_change = FALSE;
		
	foreach ($relations as $rel) {	
		$id = $rel['nid'];	
		if($id){	
			$relationship = $form_state['values'][$id];
			
			$node2_destiny_change = FALSE;
			
			//Boolean to know if we are going to add relationship in both ideas or just in the current one.
			$q_inverse = db_query("SELECT inverse FROM similar_ideas_relationtypes WHERE name='".$relationship."'");
			$result = db_fetch_array($q_inverse);  	
			$inverse = $result['inverse'];
			if($inverse !='none' && $result){
				$inverse = TRUE;
				$inverse_rel = $result['inverse'];
			}else $inverse = FALSE;
			
			$node2 = node_load($destiny_idea);
			
			if ($relationship != ''){		
			
				$destiny_idea = $id;		
		
				$node2 = node_load($destiny_idea);		
				//Checking for duplicates entrys and remove them.
				if ($actualrels[$destiny_idea]){
					//check if the relationship was changed at all and proceed with erasing the previous one only if there is a change
					if($permission){ //User can unset relationships without aproval
						
						if ($actualrels[$destiny_idea]!=$relationship) {
							//Removing from actual node.
							$field = $node->$actualrels[$destiny_idea];				
							$key = array_search(array('nid' => $destiny_idea), $field);
							unset($field[$key]);
							$node->$actualrels[$destiny_idea] = $field;
							$node1_origin_change = TRUE;
							
							//Removing from destiny node.
							//Checking if current relation have inverse relation
							$q_inverse2 = db_query("SELECT inverse FROM similar_ideas_relationtypes WHERE name='".$actualrels[$destiny_idea]."'");
							$result2 = db_fetch_array($q_inverse2);  	
							$inverse2 = $result2['inverse'];
							if($inverse2 !='none' && $result2){
								$inverse2 = TRUE;
								$inverse_rel2 = $result2['inverse'];
							}else $inverse2 = FALSE;
							
							//If inverse relation exists...
							if ($inverse2){						
								$field = $node2->$inverse_rel2;		
								$key = array_search(array('nid' => $nid), $field);
								unset($field[$key]);
								$node2->$inverse_rel2 = $field;
								$node2_destiny_change = TRUE;
							}
						}
					}
				}		
				//Storing the new relationships.
				if ($relationship){ // 0 = --Set Relationship-- So nothing to store...
					global $user;			
					$status = "pending";			
					$author = $user->name;
					$reviewer = "NONE";
					$date = time();
					$relation = substr($relationship, 15);
					if($permission){
						if ($actualrels[$destiny_idea]!=$relationship) { //check if the relationship was changed at all and proceed with setting new one only if there was a change
							$field = $node->$relationship;
							$field[]=array('nid' => $destiny_idea);			
							$node->$relationship = $field;
							$node1_origin_change = TRUE;
							
							if($inverse){
								$field = $node2->$inverse_rel;
								$field[]=array('nid' => $nid);	
								$node2->$inverse_rel = $field;
								$node2_destiny_change = TRUE;
							}
							$status = "approved";
							$reviewer = $author;
						}
					}
					
					/*
					 *Checking former pending ideas.
					 */
					$idea1 = $nid;
					$idea2 = $node2->nid;
					//Updating status if relation exists...
					$result = db_query("SELECT id FROM similar_ideas_history WHERE status='pending' AND (idea1=".$idea1." AND idea2=".$idea2.")");
					$value = db_fetch_array($result);  		
					if ($value['id']) $update = db_query("UPDATE similar_ideas_history SET status='auto-checked', reviewer='".$author."' WHERE id=".$value['id']);
					
					//Inserting new data inside history table
					$result1 = db_query("INSERT INTO  similar_ideas_history (idea1,idea2,relationship_type,author,date,status,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."',".$date.",'".$status."','".$reviewer."')");
					
					
					/*
					 *Checking for current_rels ideas
					 */
					if($permission){
						$result2 = db_query("SELECT id FROM similar_ideas_relations WHERE idea1=".$idea1." AND idea2=".$idea2);
						$value2 = db_fetch_array($result2);
						if ($value2) {
							if($relation !='NONE'){
								$update1 = db_query("UPDATE similar_ideas_relations SET idea1=".$idea1.", idea2=".$idea2.", date=".$date.", status='".$status."', reviewer='".$reviewer."', author='".$author."', relationship_type='".$relation."' WHERE id=".$value2['id']);
							}else{
								$result2 = db_query("DELETE FROM  similar_ideas_relations WHERE idea1=".$idea1." AND idea2=".$idea2);
							}
						}else{
							if($relation !='NONE') $insert2 = db_query("INSERT INTO  similar_ideas_relations (idea1,idea2,relationship_type,author,status,date,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."','".$status."',".$date.",'".$reviewer."')");
						}
					}
				}
				
				if ($node2_destiny_change) node_save($node2);
			}
		}		
	}
	if ($node1_origin_change) node_save($node);
	drupal_get_messages();	//To remove the 'We have detected some ideas...' message.
	drupal_goto("node/".$nid."/similar_ideas");
}




function panel_add($form, $form_state) {
	$nid = $form['#parameters']['2'];
	drupal_goto("similar_addrel/".$nid);
}


//Form with to add extra relationships.
function build_addform($items, $nid) {  
	return drupal_get_form('addsimilarideas',$items, $nid);
}


function addsimilarideas($form_state, $items, $nid){
	$form = array();
	
	$nd = node_load($nid);	
	$idea_status = $nd->status; //0 = unpublished, 1 = published
	
	$fields = get_relation_fields(); //Extract all fields names.
	$nodewithrelation = array (); //Array with all the node_numbers that have already a relationship 
	
	foreach ($fields as $field){
		$relations = $nd->$field; 
		if ($relations){
			foreach ($relations as $rel){ 
				$nodewithrelation[] = $rel['nid'];	
			}
		}
	}
	
	$options = get_array_options(TRUE); //function inside similar_ideas.module

	//area with input boxes for adding custom (undetected similar ideas)
	$form["similar_by_name"]["related_idea_by_title_type"] = array(
	    '#type' => 'select',
	    '#title' => t('Relationship Type'),
	    '#prefix' => '<span class="similar_ideas_rel_type">',
	    '#suffix' => '</span>',
	    '#options' => $options,
	  );
	$form["similar_by_name"]["related_idea_by_title_name"] = array(
	    '#type' => 'textfield',
	    '#title' => t('Similar Idea by Title'),
	    '#description' => 'Enter similar idea title',
	    '#size' => 70, 
      	'#maxlength' => 128, 
      	'#autocomplete_path' => 'idea/autocomplete',
	  );
	  	  
	  $form['suggestions_header'] =  array(
	    '#type' => 'item',
	    '#title' => t('Suggestions'),
	    '#description' => t('Instead of typing idea title, choose a related idea from the suggestions list.'),
	  );
	
	$flag = false;  //This boolean will be true if a node from lucene is also inside one of the four relations.
	$atLeastOne = false; //This boolean will be true if at least one combobox is created.
	
	if($items != NULL){
		$item_count = count($items);
		$current_item_count = 1;

		foreach ($items as $item) {	
		  foreach ($nodewithrelation as $nd) {		
			 if ($item['node'] == $nd) $flag = true;
		  }  
			if	(!$flag){	
				$node = node_load($item['node']);
				$title = $node->title;
				$summary = getSummary($node);
				$author = $node->name;
				$created = format_date($node->created);
				//<ul><li><li>
				$text = "<a class='tooltip' href='".$item["url"]."'>".strip_tags($item["title"])."<span class='custom info'><em>".strip_tags($title)."</em>".$summary."<br><strong>Author:</strong> ".$author."<br><strong>Created:</strong> ".$created."</span></a>";	
				
				if ($current_item_count == 1) //if first item start html list
					$html_prefix = "<ul class=\"similar_ideas_suggestion_list\"><li>"; else $html_prefix = "<li>";
				
				if ($current_item_count == $item_count) //if final item close html list tag
					$html_suffix = "</li></ul>"; else $html_suffix = "</li>";

				
				$form[$item["node"]] = array(
				 '#prefix' => $html_prefix,
				 '#suffix' => $html_suffix, //"</li></ul>",
				 '#type' => 'select',		 
				 '#title' => $text,
				 '#options' => $options,
				 
				);
				$current_item_count++;	
				$atLeastOne = true;
			}
			$flag = false;	  
		}
	}

	$botonCancelText = ''; //If there are comboboxes button will be called cancel, if not it will be called 'back'
	if ($atLeastOne){
		$form['save'] = array(
		  '#type' => 'submit',	   
		  '#value' => 'Add Relationships',
		  '#disabled' => !$idea_status,
		);
		$botonCancelText = 'Cancel';
	}else{
		$form['noone'] = array(
		  '#value' => "<span class='none'>No similar ideas detected.</span><br>",
		);
		$form['save'] = array(
		  '#type' => 'submit',	   
		  '#value' => 'Add Relationship',
		);
		$botonCancelText = 'Back';
	}
	$form['edit'] = array(
		  '#type' => 'button',
	  '#value' => $botonCancelText,	  
	  '#executes_submit_callback' => TRUE,
	  '#submit' => array('addsimilarideas_cancel'),
	);
	
	return $form;
}

//Action for cancel button (incase we are in edit-relationship)
function addsimilarideas_cancel($form) {	
	$nid = $form['#parameters']['3'];
	drupal_goto("node/".$nid."/similar_ideas");
}


//Storing in the DB: Relations stored in BOTH ideas!!
//$nid -> The idea we are evaluating.
//$destiny_Idea -> The idea that have relationship with the idea we are evaluating.
function addsimilarideas_submit($form, $form_state){
	
	$nid = $form['#parameters']['3'];
	$items = $form['#parameters']['2'];	
	
	$node1_origin_change = FALSE;
	
	//adding idea selected by title (if manually typed idea repeats on the suggestions list than its ignored)
	if ($form_state['values']['related_idea_by_title_name']!='' && $form_state['values']['related_idea_by_title_type']!='')
	{
		$related_nid = strrpos($form_state['values']['related_idea_by_title_name'], "[nid:");
		if ($related_nid == false) //if the nid was not added by auto detection check in the database
		{
			$result = db_query("SELECT nid FROM node WHERE node.type='idea' AND LOWER(title) LIKE LOWER('%s')",$form_state['values']['related_idea_by_title_name']);
			if ($data = db_fetch_object($result))
				$related_nid = $data->nid;
		} else { //if idea was selected using autocomplete extract the auto completed node nid
			$related_nid = substr($form_state['values']['related_idea_by_title_name'], $related_nid+5);
			$related_nid = substr($related_nid, 0, strlen($related_nid)-1);
		}

		if ($related_nid!=false && (!isset($form_state['values'][$related_nid]) || $form_state['values'][$related_nid]=="")) 
		{
			//before adding relationship check if it doesn't already exist
			$relationship_name = $form_state['values']['related_idea_by_title_type'];
			$result = db_query("SELECT nid FROM content_".$relationship_name." WHERE nid = %s AND ".$relationship_name."_nid = %s",$nid, $related_nid);
			$data = db_fetch_object($result);
			if ($data==NULL)
			{
				//before creating a new item check if the same idea already exists on similarity suggestions (but user did not select its relationship
				//just typed idea title manually)
				if (!isset($form_state['values'][$related_nid])) //only add new array if it does not exist yet for this idea nid
			    $items[] = array (
			        "title" => "Related idea by idea title",
			        "url" => "non",
			        "node" => $related_nid,
			      );
			    $form_state['values'][$related_nid] = $form_state['values']['related_idea_by_title_type'];
		    } //else drupal_set_message('Similar idea selected by title already has a relationship.');
      	}
    }

	$node = node_load($nid);
	foreach ($items as $item) {
		$relationship = $form_state['values'][$item['node']];
		$node2_destiny_change = FALSE;
		
		//Boolean to know if we are going to add relationship in both ideas or just in the current one.
		$q_inverse = db_query("SELECT inverse FROM similar_ideas_relationtypes WHERE name='".$relationship."'");
		$result = db_fetch_array($q_inverse);  	
		$inverse = $result['inverse'];
		if($inverse !='none' && $result){
			$inverse = TRUE;
			$inverse_rel = $result['inverse'];
		}else $inverse = FALSE;
		
		$destiny_idea = $item['node'];
		
		$node2 = node_load($destiny_idea);	
		
		
		$permission = user_access('post relationships without approval', NULL, FALSE);

		if ($relationship){ // 0 = --Set Relationship-- So nothing to store...		
			global $user;			
			$status = "pending";			
			$author = $user->name;
			$reviewer = "NONE";
			$date = time();
			$relation = substr($relationship, 15);
			
			if ($permission){//Storing the new relationships in  the fields (No aproval required)
				$field = $node->$relationship;
				$field[]=array('nid' => $destiny_idea);			
				$node->$relationship = $field;
				$node1_origin_change = TRUE;
				
				if($inverse){
					$field = $node2->$inverse_rel;
					$field[]=array('nid' => $nid);	
					$node2->$inverse_rel = $field;
					$node2_destiny_change = TRUE;
				}
				
				$status = "approved";
				$reviewer = $user->name;
			}	
			/*
			 *Checking former pending ideas.
			 */
			$idea1 = $nid;
			$idea2 = $node2->nid;
			//Updating status if relation exists...
			$result = db_query("SELECT id FROM similar_ideas_history WHERE status='pending' AND (idea1=".$idea1." AND idea2=".$idea2.")");
			$value = db_fetch_array($result);  		
			if ($value['id']) $update = db_query("UPDATE similar_ideas_history SET status='auto-checked', reviewer='".$author."' WHERE id=".$value['id']);
			
			//Inserting new data inside history table
			$result1 = db_query("INSERT INTO  similar_ideas_history (idea1,idea2,relationship_type,author,date,status,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."',".$date.",'".$status."','".$reviewer."')");
			
			
			/*
			 *Checking for current_rels ideas
			 */
			if ($status != 'pending') $status = 'approved';
			//if($permission){
				$result2 = db_query("SELECT id FROM similar_ideas_relations WHERE idea1=".$idea1." AND idea2=".$idea2);
				$value2 = db_fetch_array($result2);
				if ($value2) {
					if($relation !='NONE'){
						$update1 = db_query("UPDATE similar_ideas_relations SET idea1=".$idea1.", idea2=".$idea2.", date=".$date.", status='".$status."', reviewer='".$reviewer."', author='".$author."', relationship_type='".$relation."' WHERE id=".$value2['id']);
					}else{
						$result2 = db_query("DELETE FROM  similar_ideas_relations WHERE idea1=".$idea1." AND idea2=".$idea2);
					}
				}else{
					if($relation !='NONE') $insert2 = db_query("INSERT INTO  similar_ideas_relations (idea1,idea2,relationship_type,author,status,date,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."','".$status."',".$date.",'".$reviewer."')");
				}
			//}
		}
		if ($node2_destiny_change) node_save($node2);		
	}
	if ($node1_origin_change) node_save($node);
	drupal_get_messages();	
	drupal_goto("node/".$nid."/similar_ideas");
}

//Function to delete one relationship (by clicking the red cross)
function similar_ideas_deleterel($idea1, $idea2, $relationship) {	
	
	$nid = $idea1;	
	$node = node_load($nid, NULL, TRUE);
	$node2_destiny_change = FALSE;
	if ($node && $node->type=="idea") {			
			$actualrels = viewnoderel($node);
			$destiny_idea = $idea2;
			$node2 = node_load($destiny_idea);
			if ($actualrels[$destiny_idea]){
				global $user;			
				$status = "approved";	
				$idea1 = $nid;
				$idea2 = $node2->nid;
				$author = getAuthor($idea1,$idea2);
				$reviewer = $user->name;
				$date = time();
				$relation = "NONE";				
				
				
				//Removing from actual node.
				$field = $node->$actualrels[$destiny_idea];				
				$key = array_search(array('nid' => $destiny_idea), $field);
				unset($field[$key]);
				$node->$actualrels[$destiny_idea] = $field;
				
				//Removing from destiny node.
				//Checking if current relation have inverse relation
				$q_inverse2 = db_query("SELECT inverse FROM similar_ideas_relationtypes WHERE name='".$actualrels[$destiny_idea]."'");
				$result2 = db_fetch_array($q_inverse2);  	
				$inverse2 = $result2['inverse'];
				if($inverse2 !='none' && $result2){
					$inverse2 = TRUE;
					$inverse_rel2 = $result2['inverse'];
				}else $inverse2 = FALSE;
				
				//If inverse relation exists...
				if ($inverse2){						
					$field = $node2->$inverse_rel2;		
					$key = array_search(array('nid' => $nid), $field);
					unset($field[$key]);
					$node2->$inverse_rel2 = $field;
					$node2_destiny_change = TRUE;
				}
				
				node_save($node);
				if ($node2_destiny_change) node_save($node2); //refresh node 2 data only if the relationship is inverse and there was an actual change in the data
				
				$result1 = db_query("INSERT INTO  similar_ideas_history (idea1,idea2,relationship_type,author,date,status,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."',".$date.",'".$status."','".$reviewer."')");
				$result2 = db_query("DELETE FROM  similar_ideas_relations WHERE idea1=".$idea1." AND idea2=".$idea2." AND relationship_type='".$relationship."'");
				
				
				
				drupal_set_message("Relationship deleted properly");
			}else {
				drupal_set_message("Idea Relation not found. Please use a correct one","error");				
			}
			
			
	} else {
		drupal_set_message("Idea ID not found. Please use a correct one","error");		
	}
	$content .= "Saved";
	drupal_goto("node/".$nid."/similar_ideas");
	return $content;
}


//Function to approve or deny one relationship (by clicking the red cross)
function similar_ideas_moderaterel($rel_id, $type) {
	$symetric = 0;
	$result = null;
	if (is_numeric($rel_id)) {
		$result = db_query("SELECT * FROM similar_ideas_history WHERE id=".$rel_id);
		$value = db_fetch_array($result);  	
		if ($value['status'] == 'pending'){
			global $user;	
			$date = time();
			$reviewer = $user->name;
			$idea1 = $value['idea1'];
			$idea2 = $value['idea2'];
			$relation = $value['relationship_type'];
			$author = $value['author'];
			$status = '';
			$node1_origin_change = FALSE;
			$node2_destiny_change = FALSE;
			
			switch ($type) {				
				case 'approve':		
					$status = "approved";
					
					
					//DELETE POSIBLE FIELDS
					$node = node_load($idea1);
					$rels1 = viewnoderel($node);
					$node2 = node_load($idea2);
					$rels2 = viewnoderel($node2);
					
					$this_relation = $rels1[$node2->nid];					
					
					//Checking if current relation have inverse relation
					$q_inverse2 = db_query("SELECT inverse FROM similar_ideas_relationtypes WHERE name='field_relation_".$relation."'");
					$result2 = db_fetch_array($q_inverse2);  	
					$inverse2 = $result2['inverse'];
					if($inverse2 !='none' && $result2){
						$inverse2 = TRUE;
						$inverse_rel2 = $result2['inverse'];
					}else $inverse2 = FALSE;
					
					if (array_key_exists($node2->nid , $rels1)){
							
							
							//Removing from node1.							
							$field = $node->$this_relation;				
							$key = array_search(array('nid' => $node2->nid), $field);
							unset($field[$key]);
							$node->$this_relation = $field;	
							$node1_origin_change = TRUE;
							
							
							//If inverse relation exists...
							if ($inverse2){
								$field = $node2->$inverse_rel2;		
								$key = array_search(array('nid' => $node->nid), $field);
								unset($field[$key]);
								$node2->$inverse_rel2 = $field;
								$node2_destiny_change = TRUE;
							}
					}
				
					//INSERT FIELDS
					if ($relation != 'NONE'){
						$relationship = "field_relation_".$relation;
						
						$field = $node->$relationship;
						$field[]=array('nid' => $node2->nid);			
						$node->$relationship = $field;
						$node1_origin_change = TRUE;
						
						if($inverse2){
							$field = $node2->$inverse_rel2;
							$field[]=array('nid' => $node->nid);	
							$node2->$inverse_rel2 = $field;
							$node2_destiny_change = TRUE;		
						}
						
					}
					if ($node1_origin_change) node_save($node);
					if ($node2_destiny_change) node_save($node2);
					break;
				case 'deny':
					$status = "denied";	
					break;	
			}
			$result1 = db_query("INSERT INTO  similar_ideas_history (idea1,idea2,relationship_type,author,date,status,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."',".$date.",'".$status."','".$reviewer."')");
			$update = db_query("UPDATE similar_ideas_history SET status='checked', reviewer='".$reviewer."' WHERE id=".$rel_id);	
			
			$inverse_rel = substr($inverse_rel2, 15);
			if($inverse2){
				$result_dest = db_query("INSERT INTO  similar_ideas_history (idea1,idea2,relationship_type,author,date,status,reviewer) VALUES (".$idea2.",".$idea1.",'".$inverse_rel."','".$author."',".$date.",'".$status."','".$reviewer."')");
				$select = db_query("SELECT * FROM similar_ideas_history WHERE idea1=".$idea2." AND idea2=".$idea1." AND status='pending'");
				$s2 = db_fetch_array($select);
				if ($s2) $update_dest = db_query("UPDATE similar_ideas_history SET status='checked', reviewer='".$reviewer."' WHERE id=".$s2['id']);	
			}
			
			//Checking for current_rels ideas
			$result2 = db_query("SELECT id FROM similar_ideas_relations WHERE idea1=".$idea1." AND idea2=".$idea2);
			$value2 = db_fetch_array($result2);
			if ($value2) {
				if($relation !='NONE' && $status == 'approved'){
					$update1 = db_query("UPDATE similar_ideas_relations SET date=".$date.", status='approved', reviewer='".$reviewer."', author='".$author."' WHERE id=".$value2['id']);
				}else{
					$result2 = db_query("DELETE FROM  similar_ideas_relations WHERE idea1=".$idea1." AND idea2=".$idea2);
				}
			}else{
				if ($status == "approved") $insert2 = db_query("INSERT INTO  similar_ideas_relations (idea1,idea2,relationship_type,author,status,date,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."','".$status."',".$date.",'".$reviewer."')");
			}
			
			if ($inverse2){
				$result2 = db_query("SELECT id FROM similar_ideas_relations WHERE idea1=".$idea2." AND idea2=".$idea1);
				$value2 = db_fetch_array($result2);
				if ($value2) {
					if($relation !='NONE' && $status == 'approved'){
						$update1 = db_query("UPDATE similar_ideas_relations SET date=".$date.", status='approved', reviewer='".$reviewer."', author='".$author."' WHERE id=".$value2['id']);
					}else{
						$result2 = db_query("DELETE FROM  similar_ideas_relations WHERE idea1=".$idea2." AND idea2=".$idea1);
					}
				}else{
					if ($status == "approved")  $insert2 = db_query("INSERT INTO  similar_ideas_relations (idea1,idea2,relationship_type,author,status,date,reviewer) VALUES (".$idea2.",".$idea1.",'".$inverse_rel."','".$author."','".$status."',".$date.",'".$reviewer."')");
				}
			}
		}
		else{
			drupal_set_message("Relation ID incorrect. Not pending relationship");	
		}	
	}else{
		drupal_set_message("Relation ID has incorrect format");	
	}	
	$content .="Moderation Saved";
	drupal_goto("node/".$idea1."/similar_ideas/".$relation);
	return $content;
}


//Function to get the author of one relationship
function getAuthor($id1,$id2){	
	$result = db_query("SELECT author FROM similar_ideas_history WHERE idea1=".$id1." AND idea2=".$id2." ORDER BY date DESC");
	$value = db_fetch_array($result); 
	return $value['author'];
}


//Function to get content for the add Relationship Button.
function addRelationsPage($nid, $type){	
	global $base_path;	
	$node_path = $base_path."?q=similar_addrel/".$nid."/";
	$node = node_load($nid, NULL, TRUE);
	if ($node) {	
		//Check type from search names.
		$searchnames = get_search_names();
		$searchtypes = get_search_typesall();
		$clave = array_search($type, $searchnames);			
		if (!$type) 
		{
			//Idea Summary
			$node_disabled = "<span style=\"color: #FF7E5E;\"> (unpublished idea, relationships disabled)</span>";
			$content = "<div><p><span class='bold'><strong>Title:</strong></span> ".$node->title.($node->status==0 ? $node_disabled : "")."</p>";			
			$summary = getSummary($node);			
			$content .= "<p><span class='bold'><strong>Idea Summary:</strong></span> ".$summary."</p></div>";
			//Check type from search names.
			$searchnames = get_search_names();
			$searchtypes = get_search_typesall();
			
			//Showing terms for that "vocabulary"
			$clave = array_search($type, $searchnames);	
			if($searchnames[$clave] == $type && $searchtypes[$clave][2] == "taxonomy"){					
				foreach ($node->taxonomy as $tax){					
					if ($tax->vid == $searchtypes[$clave][5] || $searchtypes[$clave][5] == 'all'){
						$terms .= $tax->name.", ";	
					}			
				}
				$terms = substr($terms, 0, -2);
				$content .= "<div><p><span class='bold'><strong>Idea Terms:</strong></span> ".$terms."</p></div>";
			}
			$content .= "<hr style=\"background-color: #CDCDCD; margin-bottom: 10px;\"/>";
			//Related ideas
			$content .= similar_ideas_addrels($searchnames[0],$searchtypes[0][2],$nid, $node_path,0);
		}
		else if($searchnames[$clave] == $type) 
			{
				//Idea Summary
				$node_disabled = "<span style=\"color: #FF7E5E;\"> (unpublished idea, relationships disabled)</span>";
				$content = "<div><p><span class='bold'><strong>Title:</strong></span> ".$node->title.($node->status==0 ? $node_disabled : "")."</p>";			
				$summary = getSummary($node);			
				$content .= "<p><span class='bold'><strong>Idea Summary:</strong></span> ".$summary."</p></div>";
				//Check type from search names.
				$searchnames = get_search_names();
				$searchtypes = get_search_typesall();
				
				//Showing terms for that "vocabulary"
				$clave = array_search($type, $searchnames);	
				if($searchnames[$clave] == $type && $searchtypes[$clave][2] == "taxonomy"){					
					foreach ($node->taxonomy as $tax){					
						if ($tax->vid == $searchtypes[$clave][5] || $searchtypes[$clave][5] == 'all'){
							$terms .= $tax->name.", ";	
						}			
					}
					$terms = substr($terms, 0, -2);
					$content .= "<div><p><span class='bold'><strong>Idea Terms:</strong></span> ".$terms."</p></div>";
				}
				$content .= "<hr style=\"background-color: #CDCDCD; margin-bottom: 10px;\"/>";
				//Related ideas
				$content .= similar_ideas_addrels($searchnames[$clave],$searchtypes[$clave][2],$nid, $node_path,$clave);
			}
			else {
				$content .= "<div class='error_type'><span class='bold'>[Error]</span>";
				$content .= "You must specify a correct search type.</div>";
				$error = true;
			}
	} else {
		$content = "<div class='error_idea'><span class='bold'>[Error]</span><br/>";
		$content .= "You must specify a valid idea node ID.</div>";
	}
	return $content;
}

//Content shown when 'Add RelationShip' button pressed.
function similar_ideas_addrels($searchname,$searchtype,$nid, $node_path,$clave) {
	
	//get id of node that are registered as already present relationships
	$nd = node_load($nid);	
	
	$fields = get_relation_fields(); //Extract all fields names.
	$nodewithrelation = array (); //Array with all the node_numbers that have already a relationship 
	
	foreach ($fields as $field){
		$relations = $nd->$field; 
		if ($relations){
			foreach ($relations as $rel){ 
				if ($rel['nid']!= NULL)
				$nodewithrelation[] = $rel['nid'];	
			}
		}
	}
	
	//run similarity search for every registered search type
	$types = get_search_typesall();
	foreach ($types as $type){
		if ($type[2] == 'full-text') $items[] = similar_ideas_luceneapi($nid, FALSE);
		if ($type[2] == 'taxonomy') $items[] = similar_ideas_luceneapi($nid, TRUE, $type[3], $type[4],$type[5]);
		if ($type[2] == 'mixed' || $type[2] == 'mixed_or' || $type[2] == 'mixed_and') $items[] = similar_ideas_mixed($type[1],$nid,$type[2]);
	}

	$content .= "<div class='rel_types'>[ ";
		
	$names = get_search_names();	
	$ntypes = 0;
	$type_selected = 0; //Number of the selected type. Will be an index for $items[index]
	$flag = 1; //boolean for type = none, and "bold" in navigation bar
	$all_empty = 1; //boolean: 1 = every similarity types have 0 matches. 0 = matches found for at least 1 similarity type (used for skipping page...)
	
	//Construction of the relationships-navigation bar 
	foreach ($names as $name){
	
		$end = " | ";
		if (($ntypes+1) % 4 == 0) $end = " ]";
		if (($ntypes % 4 == 0) && ($ntypes > 0)) $content .= "<br>[ "; // We make the navigation bar with a max. of 4 elements per line.
		
		$nameinminus = strtolower($name);
		if ($name == $searchname || ($searchname == 'none' && $flag == 1)){
			$pre = "";
			$post = "";
			$flag = 0;
			$type_selected = $ntypes;
		}else{			
			$pre = "<a href='".$node_path.$nameinminus."'>";
			$post = "</a>";
		}
		
		if (sizeof($items[$ntypes]) > 0) $all_empty = 0; 
		
		
		$fields = get_relation_fields(); //Extract all fields names.
		
		$ids = array();
		//Count results
		foreach ($items[$ntypes] as $item){
			$ids[] = $item['node'];
		}
		
		//$fields = get_relation_fields(); //Extract all fields names.	
	
		$substract = 0;
		if ($nodewithrelation){
			foreach ($nodewithrelation as $related_nid){ 
				if ($ids && in_array($related_nid,$ids))
					$substract = $substract + 1;
			}
		}
		$n = sizeof($items[$ntypes])-$substract;
//		$n = sizeof($items[$ntypes]);
		$number = " (".$n.")";
		if ($ntypes == sizeof($names)-1) $end = " ]";
		$content .= $pre.ucfirst($name)." Search".$number.$post.$end;
		$ntypes++;
		
	}
	$content .= "</div>";
	
	
	
	$content .= build_addform($items[$type_selected], $nid); //Call to the form. This form have the Similar Ideas + Comboboxes + Buttons.
	
	return $content;
}

//Submit similar idea form. A form that enables to choose similar ideas for a specified existing idea. The difference between this form and "Add relationship" is that the following form can be invoked as a standalone page by a nonadmin user.
function report_similar_ideas($node_id) {
		$items = similar_ideas_luceneapi($node_id);
		$content .= build_report_form($items, $node_id);
		return $content;
}

//Form with to add extra relationships.
function build_report_form($items, $nid) {  
	return drupal_get_form('report_similar_ideas_form',$items, $nid);
}

function report_similar_ideas_form($form_state, $items, $nid){
	$form = array();
		
	$nd = node_load($nid);	
	
	$fields = get_relation_fields(); //Extract all fields names.
	$nodewithrelation = array (); //Array with all the node_numbers that have already a relationship 
	
	foreach ($fields as $field){
		$relations = $nd->$field; 
		if ($relations){
			foreach ($relations as $rel){ 
				$nodewithrelation[] = $rel['nid'];	
			}
		}
	}
	
	$options = get_array_options(TRUE); //function inside similar_ideas.module
	
	//idea info
	$form['original_idea'] = array(
	    '#type' => 'fieldset',
	    '#title' => t('Original Idea'),
	    '#collapsible' => FALSE,
	    '#collapsed' => FALSE,
	    '#tree' => FALSE,
	); 
	
	$form["original_idea"]["original_idea_title"] = array(
	    '#type' => 'item',
	    '#title' => t('Title'),
	    '#value' => "<a href=".url('node/'.$nd->nid.'').">".$nd->title."</a>",
	    '#prefix' => '<span class="similar_ideas_original_idea_info">',
	    '#suffix' => '</span>',
	  );
	  $idea_summary = $nd->body;
	  if (strlen($idea_summary)>150)
	  	$idea_summary = substr($idea_summary,0,150)."...";
	$form["original_idea"]["original_idea_summary"] = array(
	    '#type' => 'item',
	    '#title' => t('Idea Summary'),
	    '#value' => $idea_summary,
	    '#prefix' => '<span class="similar_ideas_original_idea_info">',
	    '#suffix' => '</span>',
	  );
	
	
	
	//area with input boxes for adding custom (undetected similar ideas)
	$form["similar_by_name"]["related_idea_by_title_type"] = array(
	    '#type' => 'select',
	    '#title' => t('Relationship Type'),
	    '#prefix' => '<span class="similar_ideas_rel_type">',
	    '#suffix' => '</span>',
	    '#options' => $options,
	  );
	$form["similar_by_name"]["related_idea_by_title_name"] = array(
	    '#type' => 'textfield',
	    '#title' => t('Select Similar Idea by Title'),
	    '#description' => 'Enter similar idea title',
	    '#size' => 70, 
      	'#maxlength' => 128, 
      	'#autocomplete_path' => 'idea/autocomplete',
	  );
	  	  
	  $form['suggestions_header'] =  array(
	    '#type' => 'item',
	    '#title' => t('Suggestions'),
	    '#description' => t('Instead of typing idea title, choose a related idea from the suggestions list.'),
	  );
	
	$flag = false;  //This boolean will be true if a node from lucene is also inside one of the four relations.
	$atLeastOne = false; //This boolean will be true if at least one combobox is created.
	
	if($items != NULL){
		$item_count = count($items);
		$current_item_count = 1;

		foreach ($items as $item) {	
		  foreach ($nodewithrelation as $nd) {		
			 if ($item['node'] == $nd) $flag = true;
		  }  
			if	(!$flag){				
			$node = node_load($item['node']);
			$title = $node->title;
			$summary = getSummary($node);
			$author = $node->name;
			$created = format_date($node->created);
			//<ul><li><li>
			$text = "<a class='tooltip' href='".$item["url"]."'>".strip_tags($item["title"])."<span class='custom info'><em>".strip_tags($title)."</em>".$summary."<br><strong>Author:</strong> ".$author."<br><strong>Created:</strong> ".$created."</span></a>";	
				
			if ($current_item_count == 1) //if first item start html list
				$html_prefix = "<ul class=\"similar_ideas_suggestion_list\"><li>"; else $html_prefix = "<li>";
			
			if ($current_item_count == $item_count) //if final item close html list tag
				$html_suffix = "</li></ul>"; else $html_suffix = "</li>";

				
			$form[$item["node"]] = array(
			 '#prefix' => $html_prefix,
			 '#suffix' => $html_suffix, //"</li></ul>",
			 '#type' => 'select',		 
			 '#title' => $text,
			 '#options' => $options,
			 
			);
			$current_item_count++;
			$atLeastOne = true;
			}
			$flag = false;
		  
		}
	}

	$botonCancelText = ''; //If there are comboboxes button will be called cancel, if not it will be called 'back'
	if ($atLeastOne){
		$form['save'] = array(
		  '#type' => 'submit',	   
		  '#value' => 'Submit request',
		);
		$botonCancelText = 'Cancel';
	}else{
		$form['noone'] = array(
		  '#value' => "<span class='none'>No similar ideas detected.</span><br>",
		);
		$form['save'] = array(
		  '#type' => 'submit',	   
		  '#value' => 'Submit request',
		);
		$botonCancelText = 'Cancel';
	}
	$form['edit'] = array(
		  '#type' => 'button',
	  '#value' => $botonCancelText,	  
	  '#executes_submit_callback' => TRUE,
	  '#submit' => array('report_similar_ideas_form_cancel'),
	);
	
	return $form;
}

//Action for cancel button (incase we are in edit-relationship)
function report_similar_ideas_form_cancel($form) {	
	$nid = $form['#parameters']['3'];
	drupal_goto("node/".$nid);
}


//Storing in the DB: Relations stored in BOTH ideas!!
//$nid -> The idea we are evaluating.
//$destiny_Idea -> The idea that have relationship with the idea we are evaluating.
function report_similar_ideas_form_submit($form, $form_state){
	
	$nid = $form['#parameters']['3'];
	$items = $form['#parameters']['2'];	
	$node1_origin_change = FALSE;
	
	//adding idea selected by title (if manually typed idea repeats on the suggestions list than its ignored)
	if ($form_state['values']['related_idea_by_title_name']!='' && $form_state['values']['related_idea_by_title_type']!='')
	{
		$related_nid = strrpos($form_state['values']['related_idea_by_title_name'], "[nid:");
		if ($related_nid == false) //if the nid was not added by auto detection check in the database
		{
			$result = db_query("SELECT nid FROM node WHERE node.type='idea' AND LOWER(title) LIKE LOWER('%s')",$form_state['values']['related_idea_by_title_name']);
			if ($data = db_fetch_object($result))
				$related_nid = $data->nid;
		} else {
			$related_nid = substr($form_state['values']['related_idea_by_title_name'], $related_nid+5);
			$related_nid = substr($related_nid, 0, strlen($related_nid)-1);
		}

		if ($related_nid!=false && (!isset($form_state['values'][$related_nid]) || $form_state['values'][$related_nid]=="")) 
		{
			//before adding relationship check if it doesn't already exist
			$relationship_name = $form_state['values']['related_idea_by_title_type'];
			$result = db_query("SELECT nid FROM content_".$relationship_name." WHERE nid = %s AND ".$relationship_name."_nid = %s",$nid, $related_nid);
			$data = db_fetch_object($result);
			if ($data==NULL)
			{
				//before creating a new item check if the same idea already exists on similarity suggestions (but user did not select its relationship
				//just typed idea title manually)
				if (!isset($form_state['values'][$related_nid])) //only add new array if it does not exist yet for this idea nid
			    $items[] = array (
			        "title" => "Related idea by idea title",
			        "url" => "non",
			        "node" => $related_nid,
			      );
			    $form_state['values'][$related_nid] = $form_state['values']['related_idea_by_title_type'];
		    }
      	}
    }

	$node = node_load($nid);
	foreach ($items as $item) {		
		$relationship = $form_state['values'][$item['node']];
		$node2_destiny_change = FALSE;
		
		//Boolean to know if we are going to add relationship in both ideas or just in the current one.
		$q_inverse = db_query("SELECT inverse FROM similar_ideas_relationtypes WHERE name='".$relationship."'");
		$result = db_fetch_array($q_inverse);  	
		$inverse = $result['inverse'];
		if($inverse !='none' && $result){
			$inverse = TRUE;
			$inverse_rel = $result['inverse'];
		}else $inverse = FALSE;
		
		$destiny_idea = $item['node'];
		$node2 = node_load($destiny_idea);	
			
		$permission = user_access('post relationships without approval', NULL, FALSE);

		if ($relationship){ // 0 = --Set Relationship-- So nothing to store...		
			global $user;			
			$status = "pending";			
			$author = $user->name;
			$reviewer = "NONE";
			$date = time();
			$relation = substr($relationship, 15);
			
			if ($permission){//Storing the new relationships in  the fields (No aproval required)
				$field = $node->$relationship;
				$field[]=array('nid' => $destiny_idea);			
				$node->$relationship = $field;
				$node1_origin_change = TRUE;
				
				if($inverse){
					$field = $node2->$inverse_rel;
					$field[]=array('nid' => $nid);	
					$node2->$inverse_rel = $field;
					$node2_destiny_change = TRUE;
				}
				$status = "approved";
				$reviewer = $user->name;
			}	
			/*
			 *Checking former pending ideas.
			 */
			$idea1 = $nid;
			$idea2 = $node2->nid;
			//Updating status if relation exists...
			$result = db_query("SELECT id FROM similar_ideas_history WHERE status='pending' AND (idea1=".$idea1." AND idea2=".$idea2.")");
			$value = db_fetch_array($result);  		
			if ($value['id']) $update = db_query("UPDATE similar_ideas_history SET status='auto-checked', reviewer='".$author."' WHERE id=".$value['id']);
			
			//Inserting new data inside history table
			$result1 = db_query("INSERT INTO  similar_ideas_history (idea1,idea2,relationship_type,author,date,status,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."',".$date.",'".$status."','".$reviewer."')");
			
			
			/*
			 *Checking for current_rels ideas
			 */
			if ($status != 'pending') $status = 'approved';
			//if($permission){
				$result2 = db_query("SELECT id FROM similar_ideas_relations WHERE idea1=".$idea1." AND idea2=".$idea2);
				$value2 = db_fetch_array($result2);
				if ($value2) {
					if($relation !='NONE'){
						$update1 = db_query("UPDATE similar_ideas_relations SET idea1=".$idea1.", idea2=".$idea2.", date=".$date.", status='".$status."', reviewer='".$reviewer."', author='".$author."', relationship_type='".$relation."' WHERE id=".$value2['id']);
					}else{
						$result2 = db_query("DELETE FROM  similar_ideas_relations WHERE idea1=".$idea1." AND idea2=".$idea2);
					}
				}else{
					if($relation !='NONE') $insert2 = db_query("INSERT INTO  similar_ideas_relations (idea1,idea2,relationship_type,author,status,date,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."','".$status."',".$date.",'".$reviewer."')");
				}
			//}	
		}
		if ($node2_destiny_change) node_save($node2);		
	}
	if ($node1_origin_change) node_save($node);
	drupal_get_messages();
	if (!user_access('post relationships without approval')) drupal_set_message("Your similarity request has been registered and will be processed by moderators shortly. Thank you for input!");
	else drupal_set_message("Reported ideas have been linked. Thank you for input!");
	drupal_goto("node/".$nid);
}
